/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#include "config.h"
#ifdef DEBUG
#define DEBUG_INTERNAL_ACCESS
#include "include.h"
#include "debug.h"
#include "fordulo.h"
#include "karakter.h"

static FILE * debugstrm = NULL;


extern int debug(t_fordulo * fordulo, char *line,...)
{
    va_list va;
    char        time_string[TIME_MAXLEN];
    struct tm * tmnow;
    time_t      now;
//    t_fordulo * fordulo = NULL;
    
    if (!fordulo)
    {
	fordulo = get_fordulo();
    }
    
    time(&now);
    if (!(tmnow = localtime(&now)))
	strcpy(time_string,"?");
    else
	strftime(time_string,TIME_MAXLEN,TIME_FORMAT,tmnow);

    if (fordulo && fordulo->karakter)
    {
	fprintf(debugstrm, "%s, %d_%d: ", time_string, fordulo->karakter->ksz, fordulo->fsz);
    }
    else
    {
	fprintf(debugstrm, "%s, ????_???:", time_string);
    }
    va_start(va, line);
    vfprintf(debugstrm, line, va);
    va_end(va);
    
    fflush(NULL);
    return 1;
}

extern int debug_open(char * filename)
{
    FILE * fp;
    
    if (!filename)
    {
	debugstrm = stderr;
	return 1;
    }
    
    if(fp = fopen(filename,"wb"))
    {
	debugstrm = fp;

	return 1;
    }    
    return 0;
}

extern int debug_close(void)
{
    if (debugstrm && debugstrm != stderr)
    {
	fflush(NULL);
	fclose(debugstrm);
	return 1;
    }
    return 0;
}

#endif /* DEBUG */

extern int gdb_stop(void)
{
    return 0;
}

