/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#include "typedef.h"
#ifndef INCLUDED_F_CSATA_TYPES
#define INCLUDED_F_CSATA_TYPES

#define CSATAVEG_SIKER_MAX 5

typedef enum
{
    spec_unknown = 0x0001,
    spec_sebez = 0x0002,
    spec_sebzodik = 0x0004,
    spec_gyogyul = 0x0008,
    spec_targypusztul = 0x0010,
    spec_varazslatlop = 0x0020,
    spec_aurakorrekcio = 0x0040,
    spec_papirang = 0x0080,
    spec_oregedes = 0x0100,
    spec_csak_kiemel = 0x0200,
    spec_csak_kozti = 0x8000
} t_spec_type;

#ifdef F_CSATA_INTERNAL_ACCESS
typedef struct spec_csata
{
    char * eleje;
    char * vege;
    char * kiemel_s;
    char * kiemel_e;
    t_spec_type type;
    char * aconf;
} t_spec_csata;
#endif /* F_CSATA_INTERNAL_ACCESS */

#endif

#ifndef JUST_NEED_TYPES
#ifndef INCLUDED_F_CSATA_PROTOS
#define JUST_NEED_TYPES
#include "fordulo.h"
extern void reformat_csata(t_fordulo * fordulo, t_csata * pcsata);
extern int csata_osszesiteshez_hozzad(t_fordulo * fordulo);
extern int csata_osszesites_kiir(t_fordulo * fordulo, t_csata * pcsata, int osszesites);
#undef JUST_NEED_TYPES
#define INCLUDED_F_CSATA_PROTOS
#endif
#endif
