/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#define F_OLIMPIA_INTERNAL_ACCESS
#include "include.h"
#include "f_olimpia.h"
#ifndef JUST_NEED_TYPES
# define JUST_NEED_TYPES
# include "fordulo.h"
# include "format.h"
# undef JUST_NEED_TYPES
#else
# include "fordulo.h"
# include "format.h"
#endif
#include "f_fordulo.h"
#include "f_csata.h"
#include "f_csatan_kivul.h"
#include "f_mezo.h"
#include "sorszam.h"
#include "output.h"

static t_spec_ep spec_ep[] =
{
 {"letpontot sebeztl.", "<font color=#006F00><b>", "</b></font>", spec_sebez},
 {"letpontot vesztettl.", "<font color=red><b>", "</b></font>", spec_sebzodik},
 {"p-t gygyultl", "<b><i>", "</i></b>", spec_gyogyul},
 {"sebzst okoz.", "<font color=#006F00><b>", "</b></font>", spec_sebez|spec_unknown},
 {"sebzst okoz.", "<font color=red><b>", "</b></font>", spec_sebzodik|spec_unknown},
 {"p-t sebezve)", "<font color=#006F00><b>", "</b></font>", spec_sebez},
 {"p-t sebez rajtad.", "<font color=red><b>", "</b></font>", spec_sebzodik},
 {"p-t sebez.", "<font color=#006F00><b>", "</b></font>", spec_sebez},
 {"p-t sebzett.)", "<font color=red><b>", "</b></font>", spec_sebzodik},
 {"pontot sebzdsz", "<font color=red><b>", "</b></font>", spec_sebzodik},
 {"pontot sebzdik", "<font color=#006F00><b>", "</b></font>", spec_sebez},
 {"p)</i></b>", "<font color=red><b>", "</b></font>", spec_sebzodik},
 {NULL, NULL}
};

static int helyezes = 0;

char * spec_ep_next(char * start, char * end, char ** eleje, char ** vege, int * vi)
{
    char * p1;
    char * p2;
    char * p3;
    char * buf;
    char * buf_vege;
    char tmp;
    int i;
    int ok;

    if (!start || !end)
    {
	return NULL;
    }
    buf = start;
    buf_vege =  buf + strlen(buf);
    tmp = *buf_vege;
    *buf_vege = '\0';

    for (i = 0, ok = 0, p1 = NULL, p2 = buf + strlen(buf); (i < (sizeof(spec_ep) / sizeof(t_spec_ep))) && spec_ep[i].mit; i++)
    {
	if ((p1 = strstr3_(buf, spec_ep[i].mit, p2, eleje, vege)))
	{
	    if (spec_ep[i].type & spec_unknown)
	    {
		if (spec_ep[i].type & spec_sebzodik)
		{
		    if ((p3 = strstr(*eleje - 20, "aurja")) && (p3 < *eleje))
		    {
			// nincs itt semmi, csak el kell kerulni az else {continue} agat
		    }
		    else if ((p3 = strstr(*eleje - 35, "Ellenfeled")) && (p3 < *eleje))
		    {
			// nincs itt semmi, csak el kell kerulni az else {continue} agat
		    }
		    else
		    {
			continue;
		    }
		}
		if (spec_ep[i].type & spec_sebez)
		{
		    if ((p3 = strstr(*eleje - 20, "aurd")) && (p3 < *eleje))
		    {
			// nincs itt semmi, csak el kell kerulni az else {continue} agat
		    }
		    else
		    {
			continue;
		    }
		}
	    }
	    if (p1 < p2)
	    {
		ok = 1;
		p2 = p1;
		*vi = i;
	    }
	}
    }
    *buf_vege = tmp;

    if (ok)
    {
	return p2;
    }
    else
    {
	return NULL;
    }
}

extern int clear_helyezes(void)
{
    helyezes = 0;
}

extern int reformat_olimpia_enemy_aname(t_fordulo * fordulo, int ssz, char * szn)
{
    char buf[32];
    int i;
    
    fordulo->mezo.x = 0;
    fordulo->mezo.y = 0;
    fordulo->mezo.ssz = 0;
    if (fordulo->mezo_type == mezo_type_oli_hely)
    {
	helyezes++;
	if ((helyezes%3) == 1)
	{
	    mezo_store(fordulo, fordulo->mezo.x, fordulo->mezo.y);
	}
	if ((i = enemy_store(fordulo, fordulo->mezo_utolso, ssz, szn)) > 0)
	{
	    output(fordulo,"<a name=\"hely%d\"></a>", i);
	}
    }
    else
    {
	mezo_store(fordulo, fordulo->mezo.x, fordulo->mezo.y);
	reformat_enemy_aname(fordulo, ssz, szn);
    }
}

extern void reformat_olimpia_csata(t_fordulo * fordulo, t_csata * pcsata)
{
    char * p1;
    char * p2;
    char * p3;
    char * p4;
    char * t1;
    char * t2;
    char * t3;
    t_csata * osszesen;
    int max;
    unsigned long int n;
    int sebzesertek;
    
    osszesen = &fordulo->osszesen;
#ifdef DEBUG
    debug(fordulo, "reformat_olimpia_csata: 1 %p\n", pcsata);
#endif
	// Az okozott sebzesek osszeszamolasa
	if ((aconf_get_curr("csata_sebzes") == 1) || (aconf_get_curr("korvege_sebzodes_stat") == 1))
	{
	    for (p1 = pcsata->eleje; (p2 = strstr2(p1, "color=#006F00><b>(")) && (p1 = strstr2(p2,")</b></font>")) && (p2 < pcsata->vege); p1 = strstr2(p2,")</b></font>"))
	    {
#ifdef DEBUG
		debug(fordulo, "reformat_olimpia_csata: sebzes: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		// utessel (x tamadassal y eletpontot...)
		if (p1 == strstr2(p2,"sebezve.)</b></font>"))
		{
		    for (p3 = p2; isdigit2(p3[0]) && (p3 <= p1); p3++);
		    for ( ; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
			pcsata->sebzes_utes += atoi(p3);
		    }
		}
		// _NEM_ utessel (x eletpontot...)
		else if (p1 == strstr2(p2,")</b></font>"))
		{
		    if (isdigit2(p2[0]))
		    {
			pcsata->sebzes_egyeb += atoi(p2);
			// Nekrocsok gyogyitasa
			if (strstr2(p1,"gygyultl.") == strstr2(p1,"."))
			{
			    char * nekro;
			    int inekro;
			
			    for (inekro = 5, nekro = p1; inekro && !isdigit2(nekro[0]); inekro--, nekro++);
			    if (isdigit2(nekro[0]))
			    {
				if (aconf_get_curr("csata_nekrocsok") == 1)
				{
				    pcsata->nekrocsok += atoi(nekro);
				}
				else
				{
				    pcsata->ep_p += atoi(nekro);
				}
			    }
		        }
		    }
		}
	    }
	}
	
	// Az elszenvedett sebzodes
	if ((aconf_get_curr("csata_sebzes") == 1) || (aconf_get_curr("korvege_sebzodes_stat") == 1))
	{
	    for (p1 = pcsata->eleje; (p2 = strstr2(p1, "color=red><b>(")) && (p1 = strstr2(p2,")</b></font>")) && (p2 < pcsata->vege); p1 = strstr2(p2,")</b></font>"))
	    {
#ifdef DEBUG
		debug(fordulo, "reformat_olimpia_csata: sebzodes: p1=%p p2=%p utes=%p %.*s\n", p1, p2, (p1 == strstr2(p2,"vesztesz.)</b></font>")), p1-p2, p2);
#endif
		// utessel (x tamadassal y eletpontot...)
		if (p1 == strstr2(p2,"vesztesz.)</b></font>"))
		{
		    for (p3 = p2; isdigit2(p3[0]) && (p3 <= p1); p3++);
		    for ( ; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
			pcsata->sebzodes_utes += atoi(p3);
		    }
		}
		// _NEM_ utessel (x eletpontot...)
		else if (p1 == strstr2(p2,")</b></font>"))
		{
		    if (*p2 == '-')
		    {
			p2++;
		    }
		    if (isdigit2(p2[0]))
		    {
			pcsata->sebzodes_egyeb += atoi(p2);
		    }
		}
	    }
	}
	
	// Kapott pluszok csatan belul
	for (p1 = pcsata->eleje; (p2 = strstr2(p1, "<b><i>(+")) && (p1 = strstr2(p2,")</i></b>")) && (p2 < pcsata->vege); p1 = strstr2(p2,")</i></b>"))
	{
	    max = 0;
	    // Max kapasa?
	    p3 = strstr2(p2,"max.");
	    if (p3 <= p1 && p3 >= p2)
	    {
		max = 1;
	    }
	    if (max)
	    {
		continue;
	    }
	    if (aconf_get_curr("csata_vampirizacio") == 1)
	    {
		// Vampirizacio
		if (p1 == strstr2(p2,"leter)</i></b>"))
		{
#ifdef DEBUG
		    debug(fordulo, "reformat_olimpia_csata: vampiri: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
			pcsata->vampiri += atoi(p3);
			continue;
		    }
		}
	    }
	    if (aconf_get_curr("korvege_csata_gyogyulas_stat") == 1)
	    {
		// Morgan szilank
		if (p1 == strstr2(p2,"letpont)</i></b>"))
		{
#ifdef DEBUG
		    debug(fordulo, "reformat_olimpia_csata: Morgan: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
			if (aconf_get_curr("csata_morgan") == 1)
			{
			    pcsata->morgan_csata += atoi(p3);
			}
			else
			{
			    osszesen->morgan_stat += atoi(p3);
			}
			continue;
		    }
		}
		// Torpregeneracio
		else if (p1 == strstr2(p2,"leter.)</i></b>"))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_olimpia_csata: torpregen: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			pcsata->torpregen += atoi(p3);
			continue;
		    }
		}
		// egyeb EP_plusz csata kozben
		else if ((p1 == strstr2(p2,"leter)</i></b>")) || (p1 == strstr2(p2,"leter.)</i></b>")) || (p1 == strstr2(p2,"letpont)</i></b>")) || (p1 == strstr2(p2,"letpont.)</i></b>")))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
#ifdef DEBUG
			debug(fordulo, "reformat_olimpia_csata: egyeb VP_plusz: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
			pcsata->ep_p += atoi(p3);
			continue;
		    }
		}
	    }
	    
#ifdef DEBUG
	    debug(fordulo, "reformat_olimpia_csata: ?_plusz: max=%d %.60s\n", max, p2);
#endif
	}

	// Kulon for-on!
	// Kobor (foldelem urai kepesseg)
	if (aconf_get_curr("korvege_csata_gyogyulas_stat") == 1)
	{
	    for (p1 = pcsata->eleje; (p2 = strstr2_(p1, "brd vdelmez", pcsata->vege - 1)) && (p1 = strstr2(p2,")")) && (p2 < pcsata->vege); p1 = strstr2(p2,")"))
	    {
#ifdef DEBUG
		debug(fordulo, "reformat_olimpia_csata: kobor: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		if (p1 == strstr2(p2,"P.)"))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
			pcsata->kobor += atoi(p3);
		    }
		}
	    }
	    // Kobor (vampir kepesseg)
	    for (p1 = pcsata->eleje; (p2 = strstr2_(p1, "seb gygyul", pcsata->vege - 1)) && (p1 = strstr2(p2,")")) && (p2 < pcsata->vege); p1 = strstr2(p2,")"))
	    {
#ifdef DEBUG
		debug(fordulo, "reformat_olimpia_csata: vampir KT: p1=%p p2=%p %.60s\n", p1, p2, p2);
#endif
		if (p1 == strstr2(p2,"P.)"))
		{
		    for (p3 = p2; !isdigit2(p3[0]) && (p3 <= p1); p3++);
		    if (isdigit2(p3[0]) && (p3 < p1))
		    {
			pcsata->vampirkt += atoi(p3);
		    }
		}
	    }
	}
	
	// Kapott minuszok csata kozben
	for (p1 = pcsata->eleje; (p4 = p1) && (p2 = strstr2(p1, "<b><i>(-")) && (p1 = strstr2(p2,")</i></b>")) && (p2 < pcsata->vege); p1 = strstr2(p2,")</i></b>"))
	{
	    max = 0;
	    // Max kapasa?
	    p3 = strstr2(p2,"max.");
	    if ((p3 <= p1) && (p3 >= p2))
	    {
		max = 1;
	    }
	    if (max)
	    {
		continue;
	    }
#ifdef DEBUG
	    debug(fordulo, "reformat_olimpia_csata: ?_minusz: max=%d %.60s\n", max, p2);
#endif
	}
	
#ifdef DEBUG
	debug(fordulo, "reformat_olimpia_csata: kiiras\n");
#endif

	// Csata kiirasa
#ifdef DEBUG
	debug(fordulo, "csata_kiir 1: neve: %.*s | block: %.20s | eleje: %.20s | vege_eleje: %.20s | vege: %.20s\n",pcsata->nevvege - pcsata->neveleje,pcsata->neveleje,pcsata->block,pcsata->eleje,pcsata->vege_eleje,pcsata->vege);
#endif
	p3 = pcsata->eleje;
	t1 = NULL;
	t2 = NULL;
	t3 = pcsata->vege_eleje;
	
#ifdef DEBUG
	output(fordulo,"---> csata start (%d)<---\r\n",pcsata->vege - pcsata->eleje);
#endif

	if ((aconf_get_curr("csata_sebzes") == 1) || (aconf_get_curr("korvege_sebzodes_stat") == 1))
	{
	    char * eleje;
	    char * vege;
	    int vi;
	    int n;
	    int m;
	    
	    for (p2 = p3 ; (p2 = spec_ep_next(p2, t3, &eleje, &vege, &vi)) && (p2 < pcsata->vege); )
	    {
		p4 = NULL;
		n = 0;
		m = 0;
		p1 = eleje - 1;
		for( ; (p1 > p3) && ((*p1 == ' ') || (*p1 == '\t') || (*p1 == '\r') || (*p1 == '\n')); p1--);
//		for( ; (p1 > p3) && (!isdigit2(*(p1-1))); p1--);
		for( ; (p1 > p3) && (isdigit2(*(p1-1))); p1--);
		if (*(vege-1) == ')')
		{
		    for(p4 = p1 ; (p4 > p3) && (*(p4-1) != '('); p4--);
		    n = 1;
		    m = 1;
		}
		if (strncmp(vege-9, ")</i></b>", 9) == 0)
		{
		    for(p4 = p1 ; (p4 > p3) && (*(p4-1) != '('); p4--);
		    n = 7;
		    m = 9;
		    if (*p4 == '-')
		    {
			p4++;
			n++;
		    }
		}
		if (isdigit2(*p1))
		{
		    sebzesertek = atoi(p1);
		    if (spec_ep[vi].type & spec_sebez)
		    {
			pcsata->sebzes_egyeb += sebzesertek;
		    }
		    else if (spec_ep[vi].type & spec_sebzodik)
		    {
			pcsata->sebzodes_egyeb += sebzesertek;
		    }
		    else if (spec_ep[vi].type & spec_gyogyul)
		    {
			pcsata->ep_n += sebzesertek;
		    }
		    if (p4)
		    {
			output(fordulo,"%.*s%s(%.*s%d %.*s)%s", p4 - p3 - n, p3, spec_ep[vi].kiemel_s, p1 - p4, p4, sebzesertek, vege - eleje - m, eleje, spec_ep[vi].kiemel_e);
		    }
		    else
		    {
			output(fordulo,"%.*s%s(%d %.*s)%s", p1 - p3, p3, spec_ep[vi].kiemel_s, sebzesertek, vege - eleje, eleje, spec_ep[vi].kiemel_e);
		    }
		    p3 = p2;
		}
	    }
	}
	
	output(fordulo,"%.*s", pcsata->vege_eleje - p3, p3);
	p3 = pcsata->vege_eleje;
	n = pcsata->vege - p3;
	output(fordulo,"%.*s", n, p3);
	
#ifdef DEBUG
	output(fordulo,"\n---> csata end <---\r\n");
#endif
	
	// Csata vegere a kulonfele dolgok kiirasa
	csata_osszesites_kiir(fordulo, pcsata, 0);
	
#ifdef DEBUG
	debug(fordulo, "reformat_olimpia_csata: osszesiteshez adasa\n");
#endif
	// Osszesiteshez a csata hozzaadasa
	csata_osszesiteshez_hozzad(fordulo);

	    if (fordulo->mezo_utolso && fordulo->mezo_utolso->enemy_utolso && !fordulo->mezo_utolso->enemy_utolso->csata)
	    {
		t_csata * ucsata;
		
		if (ucsata = malloc(sizeof(t_csata)))
		{
		    memcpy(ucsata, &fordulo->csata, sizeof(t_csata));
		    fordulo->mezo_utolso->enemy_utolso->csata = ucsata;
		}
	    }


}

void reformat_olimpia_csatan_kivul(t_fordulo * fordulo, char * start, char * end)
{
    unsigned long n;
    char * p1;
    char * p2;
    char * p3;
    char * p4;
    char * p5;
    char * p6;
    char * p7;
    char * p8;
    char * t1;
    char * t2;
    char tmp;
    int max;
    int ssz;
    char * szn;
    char * pontosnev = NULL;
    
    if (!start)
    {
#ifdef DEBUG
	debug(fordulo, "reformat_olimpia_csatan_kivul: nincs start");
#endif
	return;
    }
    if (!end)
    {
	end = start + strlen(start);
    }
	for (p3 = start, p2 = p3; (p1 = strstr(p2, "<b>")) && (p2 = strstr2(p1+3, ">")); p2 = (p3 > p2 ? p3 : p2))
	{
	    p4 = p1 + 3;
	    p4 = skip_space(p4);
#ifdef DEBUG
		debug(fordulo, "reformat_olimpia_csatan_kivul 0 %p %p %p %p \"%.*s\"\n", p3, p1, p4, p2, p2 - p1, p1);
#endif
	    if (strncmp(p4, "enc.", 4) == 0)
	    {
		continue;
	    }
	    if ((p3 >= fordulo->maradektvp) && (p3 < fordulo->korvege_tvp))
	    {
#ifdef DEBUG
		debug(fordulo, "reformat_olimpia_csatan_kivul 1\n");
#endif
		if ((p4 = strstr2(p3, "zszlt")) && (p6 = strstr(p4, "!")) && (p6 < p1))
		{
		    for (p5 = p4; (p5 < p6) && (*p5 != '.') && (*p5 != ':'); p5++);
		    p5 = skip_space(p5+1);
		    output(fordulo, "%.*s<b><font color=%s>%.*s</font></b>",p5 - p3, p3, bconf_get_value_pri("color_trezsor"), p6 - p5, p5);
		    p3 = p6;
		    if (fordulo->mezo_utolso && fordulo->mezo_utolso->enemy_utolso)
		    {
			if ((p4 = strstr(p5, "gyz")) && (p4 < p6))
			{
			    enemy_megj_set(fordulo->mezo_utolso->enemy_utolso, "gyztl");
			}
			else if ((p4 = strstr(p5, "nyer")) && (p4 < p6))
			{
			    enemy_megj_set(fordulo->mezo_utolso->enemy_utolso, "gyztl");
			}
			else if ((p4 = strstr(p5, "veszt")) && (p4 < p6))
			{
			    enemy_megj_set(fordulo->mezo_utolso->enemy_utolso, "vesztettl");
			}
		    }
		    continue;
		}
	    }
#ifdef DEBUG
	    debug(fordulo, "reformat_olimpia_csatan_kivul 2\n");
#endif
	    if ((p3 >= fordulo->korvege_tvp) && (p3 <= fordulo->end_eleje))
	    {
		if ((p4 = strstr2(p3, "egy ")) && (p7 = strstr(p4, "s ")) && (p8 = strstr(p7, "arany")) && (p8 < p1))
		{
		    char * penc1;
		    char * penc2;
		    char * penc3;
		    char * penc4;
		    
		    p7--;
		    p4 = skip_space(p4);
		    if ((penc1 = strstr(p4, "(ld.")) && (penc2 = strstr(penc1, "enc.")) && (penc3 = strstr(penc2, "</b></a>)")) && (penc3 < p7))
		    {
			p7 = penc1 - 1;
		    }
		    if (fordulo->mezo_utolso && fordulo->mezo_utolso->enemy_utolso)
		    {
			if (szn = malloc(p7-p4+1))
			{
			    sprintf(szn, "%.*s", p7 - p4, p4);
			    enemy_megj_set(fordulo->mezo_utolso->enemy_utolso, szn);
			    free(szn);
			}
		    }

		    if (p7 && (p4 = strstr(p7, "arany")) && (p6 = strstr2(p4, ".")) && (p6 < p1))
		    {
			for (p5 = p4-1; (p5 > p3) && ((*p5 == ' ') || (*p5 == '\t') || (*p5 == '\r') || (*p5 == '\n')); p5--);
			if (helyezes && (helyezes%3 == 0))
			{
			    if (isdigit2(*p5))
			    {
				output(fordulo, "%.*s<p>", p6 - p3, p3);
				p3 = p6;
			    }
			}
		    }
		}
		else if ((p4 = strstr2_(p3, "tvehetik nyeremnyket.", p1)))
		{
		    output(fordulo, "%.*s<p>", p4 - p3, p3);
		    p3 = p4;
		}
		else if ((p4 = strstr_(p3, "Ezzel a bajnoksg vget rt!", p1)))
		{
		    output(fordulo, "%.*s<p>", p4 - p3, p3);
		    p3 = p4;
		}
	    }

#ifdef DEBUG
	    debug(fordulo, "reformat_olimpia_csatan_kivul 3\n");
	    output(fordulo, "---> ettol1(%i) <---\r\n%.*s---> eddig1 <---\r\n", p1 - p3, p1 - p3, p3);
#else
	    output(fordulo, "%.*s", p1 - p3, p3);
#endif
	    p3 = p1;
	    
	    if (p2 != strstr2(p1+3, "</b>"))
	    {
		p2 = strstr2(p1+3, "</b>");
		if (p4 = strstr_(p1, "ENCYCLOPEDIA FANTASIA", p2))
		{
		    output(fordulo, "<p>%.*s", p2 - p3, p3);
		}
		else
		{
		    output(fordulo, "%.*s", p2 - p3, p3);
		}
		p3 = p2;
		continue;
	    }
	    if ((p4 = strstr2(p2, "llsz.")) && (p4 == strstr2(p2,".")))
	    {
	        output(fordulo, "%.*s<p>", p4 - p3, p3);
		p3 = p4;
		continue;
	    }
	    if ((p4 = strstr2(p2, "el!")) && (p4 == strstr2(p2,"!")))
	    {
	        output(fordulo, "%.*s<p>", p4 - p3, p3);
		p3 = p4;
		continue;
	    }
#ifdef DEBUG
	    debug(fordulo, "reformat_olimpia_csatan_kivul 4\n");
#endif
	    if ((*(p2 - 5)  != '>') && (*(p2 - 5)  != ')'))
	    {
		if (szn = malloc(p2-p1-6))
		{
		    sprintf(szn,"%.*s",p2-p1-7, p1+3);
		    ssz = karakter_get_szam(szn, &pontosnev);
#ifdef DEBUG
		    debug(fordulo, "reformat_olimpia_csatan_kivul ssz=%d\n", ssz);
#endif
		    if (ssz)
		    {
			if (start >= fordulo->maradektvp)
			{
			    reformat_olimpia_enemy_aname(fordulo, ssz, szn);
			}
			output(fordulo, "<b>%s (#%i)</B>", szn, ssz);
		    }
		    else
		    {
			if (start >= fordulo->maradektvp)
			{
			    reformat_olimpia_enemy_aname(fordulo, ssz, szn);
			}
			output(fordulo, "<b>%s</B>", szn);
		    }
		    p3 = p2;
		    if (pontosnev)
		    {
			free(pontosnev);
			pontosnev = NULL;
		    }
		    free(szn);
		}
		else
		{
#ifdef DEBUG
		    debug(fordulo, "reformat_olimpia_csatan_kivul malloc error\n");
#endif
		    output(fordulo, "%.*s", p2 - p1, p1);
		    p3 = p2;
		}
	    }
	    else
	    {
#ifdef DEBUG
	    debug(fordulo, "reformat_olimpia_csatan_kivul 4\n");
	    output(fordulo, "---> ettol2(%i) <---\r\n%.*s---> eddig2 <---\r\n", p2 - p1, p2 - p1, p1);
#else
	    output(fordulo, "%.*s", p2 - p1, p1);
#endif
	    p3 = p2;
	    }
	}

	if ((p3 >= fordulo->korvege_tvp) && (p4 = strstr_(p3, "Ezzel a bajnoksg vget rt!", end)))
	{
	    output(fordulo, "%.*s<p>", p4 - p3, p3);
	    p3 = p4;
	}
	n = end - p3;
#ifdef DEBUG
	output(fordulo, "---> ettol(%i) <---\r\n%.*s---> eddig <---\r\n", n, n, p3);
#else
	output(fordulo, "%.*s", n, p3);
#endif	
}

extern int helyezesek_kiir(t_fordulo * fordulo)
{
    t_mezo * mezo;
    t_enemy * enemy;
    int i;
    int j;
    
    if (!fordulo)
    {
	return -1;
    }
    if (!fordulo->mezo_elso)
    {
	return 0;
    }
    output(fordulo,"<P><TABLE WIDTH=100%% CELLPADDING=1 CELLSPACING=0 BORDER=0 CLASS=\"t0\"><TR><TD> <TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0 CLASS=\"t1\" WIDTH=100%%>\r\n<TR><TD CLASS=\"c2\" COLSPAN=5>%s</TD></TR>\r\n", "HELYEZETTEK");

    for (i = 1, mezo = fordulo->mezo_elso; mezo; mezo = mezo->next, i++)
    {
	output(fordulo, "<tr valign=\"top\"><td nowrap class=\"t1\"> &nbsp;&nbsp;&nbsp;</td><td nowrap class=\"t1\">%d. kategoria:</td>", i);
	if (mezo->enemy_elso)
	{
	    for (j = 0, enemy = mezo->enemy_elso; enemy; enemy = enemy->next, j++)
	    {
		output(fordulo, "<td class=\"t1\">");
		if (enemy->ssz)
		{
		    output(fordulo, "<b><i>(%d.)</i></b> <a class=n href=\"#hely%d\">%s (#%d)<a>", j+1, enemy->aname, enemy->nev, enemy->ssz);
		}
		else
		{
		    output(fordulo, "<b><i>(%d.)</i></b> <a class=n href=\"#hely%d\">%s<a>", j+1, enemy->aname, enemy->nev);
		}
		if (enemy->megj)
		{
		    output(fordulo, "<br> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i>[%s]</i>", enemy->megj);
		}
		output(fordulo, "&nbsp;</td>");
	    }
	}
	output(fordulo, "</tr>\r\n");
    }
    output(fordulo,"</table></td></tr></table><br><br>\r\n");
}


void reformat_olimpia_korvege(t_fordulo * fordulo, char * buf)
{
    char * p1;
    char * p2;
    int tablazat;
    long int csata_gyogyulas = 0;
    long int csata_vp = 0;
    long int csata_pp = 0;
    int csata_kiir = 0;
    int eroforras_kiir = 0;
    int permanens_kiir = 0;

#ifdef DEBUG
    output(fordulo, "---> korvege start<---\r\n");
#endif
    // Ellenfelek kiirasa
    output(fordulo,"<P>\r\n");
    kalandozocsata_kiir(fordulo);
//    mezo_kiir(fordulo);
    mezo_store_delete(fordulo);
    
#ifdef DEBUG
    output(fordulo, "korvege end<---\r\n");
#endif
    tablazat = 0;
    if ((p1 = strstr(buf, "<p><center><h2>")) && (p2 = strstr2(p1, "EREDMNYHIRDETS")) && (p2 = strstr2(p2, "</h2></center>")) && (p2 = strstr2(p2, "<p></b>")) && (p2 == strstr2(buf, "<p></b>")))
    {
	output(fordulo,"<P><TABLE WIDTH=100%% CELLPADDING=1 CELLSPACING=0 BORDER=0 CLASS=\"t0\"><TR><TD> <TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0 CLASS=\"t1\" WIDTH=100%%>\r\n<TR><TD CLASS=\"c2\" COLSPAN=2>%s</TD></TR>\r\n", "EREDMNYHIRDETS");
	output(fordulo, "<tr valign=\"top\"><td class=\"t1\">\r\n");
	tablazat = 1;
	buf = p2;
    }
    clear_helyezes();
    fordulo->mezo_type = mezo_type_oli_hely;
    reformat_olimpia_csatan_kivul(fordulo, buf, buf + strlen(buf));
    if (tablazat)
    {
	output(fordulo, "</td></tr>\r\n");
	output(fordulo,"</table></td></tr></table><br><br>\r\n");
    }

    // Helyezettek kiirasa
    helyezesek_kiir(fordulo);
}

void reformat_olimpia(t_fordulo * fordulo, char * buf)
{
    unsigned long n;
    char * p1;
    char * p2;
    char * p3;
    char * t1;
    char * t2;
    char tmp;
    t_csata * pcsata;
    t_csata * osszesen;
    
    pcsata = &fordulo->csata;
    osszesen = &fordulo->osszesen;
    csata_next(NULL, pcsata);
    pcsata->fordulo = fordulo;
#ifdef DEBUG
    debug(fordulo, "reformat_olimpia 1: buf=%p, \"%s\"\n", buf, buf);
#endif
    // Vegigmegy csatankent, a visszaadott ertek a csata vege!
    for ( t1 = buf; t1 && (t2 = csata_next(t1, pcsata)); t1 = t2)
    {
#ifdef DEBUG
	debug(fordulo, "reformat_olimpia 2: t1=%p t2=%p\n", t1, t2);
#endif
	// Csata elotti resz feldolgozasa ES(!!!) kiirasa
	tmp = *pcsata->eleje;
	*pcsata->eleje = '\0';
	reformat_olimpia_csatan_kivul(fordulo, pcsata->block, pcsata->eleje);
	*pcsata->eleje = tmp;
#ifdef DEBUG
	debug(fordulo, "reformat_olimpia 4: t1=%p t2=%p\n", t1, t2);
#endif
	// Csata feldolgozasa ES(!!!) kiirasa
	tmp = *pcsata->vege;
	*pcsata->vege = '\0';
	reformat_olimpia_csata(fordulo, pcsata);
	*pcsata->vege = tmp;

    } // enf of for(next_csata)
#ifdef DEBUG
    debug(fordulo, "reformat_olimpia utani resz kiiras: %.60s\n", t1);
#endif
    // Utolso csata utani resz kiirasa ES(!!!) feldolgozasa
    reformat_olimpia_csatan_kivul(fordulo, t1, t1 + strlen(t1));
}
