/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#include "typedef.h"
#ifndef INCLUDED_FEGYVER_TYPES
#define INCLUDED_FEGYVER_TYPES
#ifndef JUST_NEED_TYPES
# define JUST_NEED_TYPES
# include "sebzes.h"
# include "targy.h"
# include "karakter.h"
# undef JUST_NEED_TYPES
#else
# include "sebzes.h"
# include "targy.h"
# include "karakter.h"
#endif

typedef enum
{
    fegyver_type_none = 0x0000,
    fegyver_type_balkez = 0x0001,
    fegyver_type_ezust = 0x0002,
    fegyver_type_magic = 0x0004,
    fegyver_type_okol = 0x0100,
    fegyver_type_szuro = 0x0200,
    fegyver_type_vago = 0x0400,
    fegyver_type_uto = 0x0800,
    fegyver_type_lo = 0x1000,
    fegyver_type_dobo = 0x2000,
    fegyver_type_vizi = 0x4000
} t_fegyver_type;

struct fegyver
{
    t_fegyver_type type;
    int minfv;
    t_sebzes sebzes;
    t_spell * spell;
    int spellesely;
    int spellero;
    struct fegyver * next;
    struct targy * targy;
};


#endif

#ifndef JUST_NEED_TYPES
#ifndef INCLUDED_FEGYVER_PROTOS
#define INCLUDED_FEGYVER_PROTOS
extern char * get_fegyvertipus_neve(int i);
extern t_fegyver * fegyver_create(t_targy * targy, t_fegyver_type type, t_sebzes * sebzes, int spellssz, int spellero, int spellesely);
extern float get_okol_sebzes(t_karakter * karakter, t_fegyver * fegyver);
extern t_fegyver_type get_fegyver_type_from_targy_tipus(int ssz, t_targy_tipus tipus, int balkez);
#endif
#endif
