/*
 * Copyright (C) 2003-2005  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#define FORMAT_INTERNAL_ACCESS
#include "include.h"
#include "format.h"
#include "output.h"
#include "f_fordulo.h"
#include "f_karlap.h"
#include "f_korvege.h"
#include "f_csata.h"
#include "f_csatan_kivul.h"
#include "conf.h"
#include "cache.h"
#include "globals.h"
#ifndef JUST_NEED_TYPES
# define JUST_NEED_TYPES
# include "fordulo.h"
# undef JUST_NEED_TYPES
#else
# include "fordulo.h"
#endif

static t_enc encek[] =
{
 { encek_type_szorny, ". SZRNY)"  },
 { encek_type_szorny, ". TESZT SZRNY)"  },
 { encek_type_szorny, ". FAJ)"  },
 { encek_type_szorny, ". ELLENFL)"  },
 { encek_type_szorny, ". LNY)"  },
 { encek_type_szorny, ". VIHARRIS)"  },
 { encek_type_szorny, ". THARGODAN)"  },
 { encek_type_szorny, ". SRKNY)"  },
 { encek_type_targy, ". TRGY)"  },
 { encek_type_targy, ". SZRNYCSAPDA)"  },
 { encek_type_targy, ". TEREPTRGY)"  },
 { encek_type_targy, ". NVNY)"  },
 { encek_type_targy, ". PTMNY)"  },
 { encek_type_recept, ". RECEPT)"  },
 { encek_type_varazslat, ". VARZSLAT)"  },
 { encek_type_kepesseg, ". ALAKVLT KPESSG)"  },
 { encek_type_tudati, ". TUDAT KPESSG)"  },
 { encek_type_tudati, ". TUDATI KPESSG)"  },
 { encek_type_tudati, ". KT KPESSG)"  },
 { encek_type_pszi, ". PSZI KPESSG)"  },
 { encek_type_pszi, ". PSZI TMAD KPESSG)"  },
 { encek_type_pszi, ". VDEKEZ PSZI KPESSG)"  },
 { encek_type_pszi, ". TMAD PSZI KPESSG)"  },
 { encek_type_varazslat, ". PAPI VARZSLAT)"  },
 { encek_type_varazslat, ". PAP VDEKEZ VARZSLAT)"  },
 { encek_type_varazslat, ". PAP TMAD VARZSLAT)"  },
 { encek_type_varazslat, ". PAPI VDEKEZ VARZSLAT)"  },
 { encek_type_varazslat, ". PAPI TMAD VARZSLAT)"  },
 { encek_type_varazslat, ". TMAD PAP VARZSLAT)"  },
 { encek_type_varazslat, ". VARZSL VARZSLAT)"  },
 { encek_type_varazslat, ". VDEKEZ VARZSLAT)"  },
 { encek_type_varazslat, ". TMAD VARZSLAT)"  },
 { encek_type_varazslat, ". VDEKEZ VARZSL VARZSLAT)"  },
 { encek_type_varazslat, ". TMAD VARZSL VARZSLAT)"  },
 { encek_type_varazslat, ". EZST KDEX VARZSLAT)"  },
 { encek_type_varazslat, ". VDEKEZ STEOLGIA VARZSLAT)"  },
 { encek_type_varazslat, ". TMAD STEOLGIA VARZSLAT)"  },
 { encek_type_varazslat, ". STEOLGIA VARZSLAT)"  },
 { encek_type_varazslat, ". VDEKEZ STAUMATURGIA VARZSLAT)"  },
 { encek_type_varazslat, ". TMAD STAUMATURGIA VARZSLAT)"  },
 { encek_type_varazslat, ". STAUMATURGIA VARZSLAT)"  },
 { 0, NULL}
};

extern int stat_get_max(void)
{
    t_csata csata;
    int i;
    
    i = &csata.egyeb_n - &csata.sebzes_utes + 1;
    return i;
}

void reformat_else(t_fordulo * fordulo, char * buf)
{
    if (strlen(buf))
    {
#ifdef DEBUG
	output(fordulo, "---> else start<---\r\n%s---> else end<---\r\n", buf);
#else
	output(fordulo, "%s", buf);
#endif
    }
}

void reformat_ktjelentes(t_fordulo * fordulo, char * buf)
{
    reformat_else(fordulo, buf);
}

void reformat_fejlec(t_fordulo * fordulo, char * buf)
{
    char * p1;
    char * p2;
    char * p3;
    char * p4;
    char * taplalascella;
    int n;
    int ok;
    
    if (!buf)
    {
	return;
    }
        
    p1 = buf;
#ifdef DEBUG
    debug(fordulo, "reformat_fejlec: \"%s\"\n", buf);
#endif
    if (strlen(p1))
    {
	ok = 0;
	if ((fordulo->tipus & fordulo_tipus_wrapper) && (p2 = strstr2(p1, "</TITLE>")))
	{
	    ok = 2;
	}
	else if (p2 = strstr(p1, "\r\n-->\r\n"))
	{
	    ok = 1;
	}
	else if ((fordulo->tipus & fordulo_tipus_olimpia) && !strstr(p1, "<HEAD>") && (p2 = strstr(p1, "<body bgcolor=white>")))
	{
	    ok = 3;
	}
	if (ok)
	{
	    n = p2 - p1;
	    if (ok == 3)
	    {
		output(fordulo, "<HTML>\r\n<HEAD\r\n>%.*s", n, p1);
		if ((p3 = strstr2(p1, "<p><center><h2>")) && (p4 = strstr2(p3, "RSZVTELE AZ OLIMPIN")))
		{
		    output(fordulo, "<TITLE>\r\n %.*s\r\n</TITLE>", p4 - p3, p3);
		}
		
	    }
	    else
	    {
		output(fordulo, "%.*s\r\n", n, p1);
	    }
	    if ((ok == 2) || (ok == 3))
	    {
		output(fordulo, "<STYLE TYPE=\"text/css\">\r\n<!--\r\n");
	    }
	    if (ok == 3)
	    {
                output(fordulo, "  a:link {Color: Blue; Text-decoration: None;}\r\n");
                output(fordulo, "  a:visited {Color: Blue; Text-decoration: None;}\r\n");
                output(fordulo, "  a:hover {Color: Blue; Text-decoration: None;}\r\n");
                output(fordulo, "  a:active {Color: Blue; Text-decoration: None;}\r\n");
                output(fordulo, "  BODY{ TEXT-ALIGN: justify; BACKGROUND: White; COLOR: Black;}\r\n");
                output(fordulo, "  TABLE{ TEXT-ALIGN: Justify;}\r\n");
                output(fordulo, "  .tenc{ COLOR: Black;}\r\n");
                output(fordulo, "  .c1{ BACKGROUND: #DDDDDD; COLOR: White; FONT-WEIGHT: bold; FONT-SIZE: 20px; TEXT-ALIGN: center;}\r\n");
                output(fordulo, "  .c2{ BACKGROUND: #E0E0E0; FONT-WEIGHT: bold; FONT-SIZE: 15px; TEXT-ALIGN: center;}\r\n");
                output(fordulo, "  .c3{ BACKGROUND: #EEEEEE; FONT-WEIGHT: bold; FONT-SIZE: 13px; TEXT-ALIGN: left;}\r\n");
                output(fordulo, "  .klap{ COLOR: Black; FONT-FAMILY: Trebuchet MS, Arial, Helvetica, Sans-Serif; FONT-SIZE: 13px;}\r\n");
                output(fordulo, "  .t1{ FONT-SIZE: 13px; BACKGROUND: White; COLOR: Black;}\r\n");
                output(fordulo, "  .t0{ BACKGROUND: #EEEEEE;}\r\n");
                output(fordulo, "  .k{ FONT-WEIGHT: Bold;}\r\n");
                output(fordulo, "  .p{ COLOR: Black; FONT-WEIGHT: Bold;}\r\n");
                output(fordulo, "  .feltpar{ FONT-WEIGHT: bold; FONT-STYLE: Italic;}\r\n");
                output(fordulo, "  .szogletes{ COLOR: Black; FONT-WEIGHT: Normal;}\r\n");
                output(fordulo, "  .kapcsos{ COLOR: Black; FONT-STYLE: Italic; FONT-WEIGHT: Normal;}\r\n");
                output(fordulo, "  .tp{ COLOR: Blue; FONT-WEIGHT: Normal;}\r\n");
                output(fordulo, "  .szenved{ COLOR: Red; FONT-WEIGHT: Bold;}\r\n");
                output(fordulo, "  .sebez{ COLOR: Green; FONT-WEIGHT: Bold;}\r\n");
                output(fordulo, "  .tvp{ COLOR: #444444; FONT-WEIGHT: Bold;}\r\n");
                output(fordulo, "  .reflist{ FONT-SIZE: 12px; TEXT-ALIGN: Left;}\r\n");
                output(fordulo, "  .plusminus{ FONT-STYLE: Normal; FONT-WEIGHT: Bold;}\r\n");
                output(fordulo, "  .q{ BACKGROUND: Black;}\r\n");
                output(fordulo, "  .t{ BACKGROUND: White; COLOR: #000060; FONT-WEIGHT: Bold; FONT-SIZE: 12px; TEXT-ALIGN: Center;}\r\n");
                output(fordulo, "  .tj{ TEXT-ALIGN: Center; FONT-WEIGHT: Bold; FONT-SIZE: 14px;}\r\n");
	    }
	    output(fordulo, "  .trezsor{ COLOR: %s; FONT-WEIGHT: Bold;}\r\n", bconf_get_value_pri("color_trezsor"));
	    output(fordulo, "  .koord{ COLOR: %s; FONT-WEIGHT: Bold;}\r\n", bconf_get_value_pri("color_koordinata"));
	    output(fordulo, "  .onanalizis{ COLOR: %s; FONT-WEIGHT: Bold;}\r\n", bconf_get_value_pri("color_onanalizis"));
	    output(fordulo, "  a.n:link { COLOR:  %s; }\r\n", bconf_get_value_pri("color_webhyperlink"));
	    output(fordulo, "  a.n:visited { COLOR:  %s; }\r\n", bconf_get_value_pri("color_webhyperlink"));
	    output(fordulo, "  a.n:hover { COLOR:  %s; text-decoration: underline; }\r\n", bconf_get_value_pri("color_webhyperlink"));
	    output(fordulo, "  a.n:active { COLOR:  %s; }", bconf_get_value_pri("color_webhyperlink"));
	    if ((ok == 2) || (ok == 3))
	    {
		output(fordulo, "\r\n-->\r\n</STYLE>");
	    }
	    if (ok == 3)
	    {
		output(fordulo, "<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"profile.css\">\r\n</HEAD>\r\n");
	    }
	    p1 = p2;
	}
	if (ok == 3)
	{
	    taplalascella = "<td>Betpllva:";
	    if (p2 = strstr(p1, taplalascella))
	    {
		output(fordulo, "%.*s<td width=50%%>Betpllva:", p2 - p1, p1);
		p1 = p2 + strlen(taplalascella);
	    }
	    taplalascella = ">KALANDOZ:";
	    if (p2 = strstr(p1, taplalascella))
	    {
		output(fordulo, "%.*s width=25%%>&nbsp;</td><td valign=top>KALANDOZ:", p2 - p1, p1);
		p1 = p2 + strlen(taplalascella);
	    }
	}
	ok = 0;
	if ((fordulo->tipus & fordulo_tipus_olimpia) && (p2 = strstr2(p1, "</td></tr></table>")))
	{
	    ok = 2;
	}
	else if ((p2 = strstr2(p1, "</TD></TR></TABLE></TD></TR></TABLE>")))
	{
	    ok = 1;
	}
	if (ok)
	{
	    n = p2 - p1;
	    output(fordulo, "%.*s\r\n", n, p1);
	    output(fordulo,"<BR><A HREF=#reformat>%s</A><BR>\r\n", VERSION);
	    p1 = p2;
	}
	output(fordulo, "%s\r\n", p1);
    }
}

extern int referencia_check(t_fordulo * fordulo)
{
    char * p1;
    char * p2;
    char * p3;
    char * p4;
    int ssz;
    int i;
    int ibuf[3];
    
    if (!fordulo || !fordulo->ref_szorny || !fordulo->ref_targy || !fordulo->ref_parancs)
    {
	return -1;
    }
    
    p2 = fordulo->ref_szorny;
    for (p2 = fordulo->ref_szorny, p3 = p2; (p1 = strstr2(p2, "(#")) && (p2 = strstr(p1, ")")) && (p2 < fordulo->ref_parancs); p3 = p2)
    {
	if (isdigit2(*p1))
	{
	    ssz = atoi(p1);
	    
	    if (!fordulo->cache)
	    {
		if (!(fordulo->cache = cache_create(fordulo)))
		{
		    break;
		}
	    }
	    
	    ibuf[0] = ssz;
	    ibuf[1] = fordulo->fsz;
	    
	    if ((p1 > fordulo->ref_szorny) && (p1 < fordulo->ref_targy))
	    {
		ibuf[2] = (int)cache_monster_flag_ismert;
		cache_add_monster(fordulo->cache, ibuf, sizeof(ibuf)/sizeof(int));
	    }
	    else if ((p1 > fordulo->ref_targy) && (p1 < fordulo->ref_parancs))
	    {
		if ((p4 = strstr(p3, "$")) && (p4 < p1))
		{
		    ibuf[2] = (int)cache_item_flag_hu;
		}
		else
		{
		    ibuf[2] = (int)cache_item_flag_ismert;
		}
		cache_add_item(fordulo->cache, ibuf, sizeof(ibuf)/sizeof(int));
	    }
	}
    }
    
    return 0;
}

int reformat_referencia(t_fordulo * fordulo, char * buf)
{
    char * t1;

    t1 = buf;
    
    if (get_cache_mode())
    {
	return;
    }
    
    reformat_else(fordulo, t1);
}

int reformat_encek(t_fordulo * fordulo, char * buf)
{
    char * t1;
    char * p1;
    char * p2;
    char * p3;
    char * p4;
    char * p5;
    char delim;
    char * hyper;
    char tmp;
    int ssz;
    t_cache_type cache_type;
    int i;
    int ibuf[3];
    
    t1 = buf;
    // cache
    for (p2 = t1; (p1 = strstr2(p2, "CLASS=\"tenc\"")) && (p1 = strstr2(p1, "(")) && (p2 = strstr(p1, ")")); )
    {
	if (isdigit2(*p1))
	{
	    ssz = atoi(p1);
	    
	    p1 = skip_nonspace(p1);
	    p1--;
	    if (*p1 != '.')
	    {
		continue;
	    }
	    
	    cache_type = cache_type_none;
	    
	    for (i = 0; (i < sizeof(encek)/sizeof(t_enc)) && encek[i].name; i++)
	    {
		if (strncmp(p1, encek[i].name, strlen(encek[i].name)) == 0)
		{
		    cache_type = encek[i].type;
		    break;
		}
	    }
	    
	    if (!fordulo->cache)
	    {
		if (!(fordulo->cache = cache_create(fordulo)))
		{
		    break;
		}
	    }
	    
	    ibuf[0] = ssz;
	    ibuf[1] = fordulo->fsz;
	    
	    switch (cache_type)
	    {
		case cache_type_monster:
			ibuf[2] = (int)cache_monster_flag_ismert;
			cache_add_monster(fordulo->cache, ibuf, sizeof(ibuf)/sizeof(int));
			break;
		case cache_type_item:
			ibuf[2] = (int)cache_item_flag_ismert;
			cache_add_item(fordulo->cache, ibuf, sizeof(ibuf)/sizeof(int));
			break;
		default:
			break;
	    }
	}
    }
    
    if (get_cache_mode())
    {
	return;
    }
    
    // kiiras
    hyper = bconf_get_webhyper();
    if (hyper[0] == '/')
    {
        delim = '/';
    }
    else if (hyper[2] == '\\')
    {
        delim = '\\';
    }
    else
    {
	delim = '\0';
    }
    
    if (delim != '\0' && (strncmp(hyper, "http://", 7) != 0))
    {
	for( ; (p1 = strstr(t1, "SRC=\"http://www.beholder.hu/pic")); t1 = p3)
	{
	    p1 += 5;
	    p2 = p1 + 7;
	    if (!(p3 = strstr2(p2, "\"")))
	    {
		break;
	    }
	    
	    if (p4 = malloc(p3 - p2 + 1))
	    {
		sprintf(p4, "%.*s", p3 - p2, p2);
		if (delim != '/')
		{
		    for (p5 = p4; p5 < p4 + strlen(p4); p5++)
		    {
			if (*p5 == '/')
			{
			    *p5 = delim;
			}
		    }
		}
		output(fordulo, "%.*s%s%s", p1 - t1, t1, bconf_get_webhyper(), p4);
		free(p4);
		p4 = NULL;
	    }
	    else
	    {
		output(fordulo, "%.*s", p3 - t1, t1);
	    }
	}
    }
    reformat_else(fordulo, t1);
}

extern int reformat(t_fordulo * fordulo)
{
    char ** p1;
    char ** p2;
    char * px;
    char * t1;
    char * t2;
    char * buf;
    char tmp;
    unsigned long n;
    int i;
    int size;
    
    kiir(fordulo, "ReFormating");
    fordulo->osszesen.fsz = fordulo->fsz;
    for (i = 1, size = 0, p1 = &fordulo->fejlec; p1 < &fordulo->end; p1 = p2, i++)
    {
#ifdef DEBUG
# ifdef USE_CHECK_ALLOC
//    check_report_usage();
# endif
#endif
	p2 = p1 + 1;
#ifdef DEBUG
	debug(fordulo, "fordulo reformat 1: p1=%p p2=%p\n", *p1, *p2);
#endif
	if (*p1 == NULL)
	{
	    continue;
	}
#ifdef DEBUG
	debug(fordulo, "fordulo reformat 2: p1=%p p2=%p\n", *p1, *p2);
#endif
	while (((*p2 == NULL) || (*p2 < *p1)) &&  (p2 < &fordulo->end))
	{
	    p2++;
	}
	tmp = **p2;
	**p2 = '\0';
#ifdef DEBUG
	debug(fordulo, "fordulo reformat 3: p1=%p p2=%p\n", *p1, *p2);
#endif
	kiir(fordulo, ".");
	fordulo->p = NULL;
	if ((p1 > &fordulo->fejlec) && (p1 < &fordulo->korvege_tvp) && (p2 <= &fordulo->korvege_tvp))
	{
	    if (fordulo->tipus == fordulo_tipus_olimpia)
	    {
#ifdef DEBUG
		debug(fordulo, "fordulo reformat olimpia: %.100s\n", *p1);
#endif
		fordulo->mezo_type = mezo_type_oli_ellen;
		if (!get_cache_mode())
		{
		    reformat_olimpia(fordulo, *p1);
		}
	    }
	    else
	    {
#ifdef DEBUG
		debug(fordulo, "fordulo reformat parancs: %.100s\n", *p1);
#endif
		if ((p1 == &fordulo->maradektvp) && fordulo->maradektvp_parancs && fordulo->maradektvp_parancs->parancs)
		{
		    char ttmp;
		    t_maradektvp_parancs * maradektvp_parancs = fordulo->maradektvp_parancs;
		    t_maradektvp_parancs * maradektvp_parancs_next;
#ifdef DEBUG
		    debug(fordulo, "fordulo reformat maradektvp\n");
#endif
		    ttmp = *maradektvp_parancs->parancs;
		    *maradektvp_parancs->parancs = '\0';
		    reformat_fordulo(fordulo, *p1);
		    *maradektvp_parancs->parancs = ttmp;
		    
		    for (maradektvp_parancs = fordulo->maradektvp_parancs; maradektvp_parancs; maradektvp_parancs = maradektvp_parancs_next)
		    {
			maradektvp_parancs_next = maradektvp_parancs->next;
			if (maradektvp_parancs_next)
			{
			    ttmp = *maradektvp_parancs_next->parancs;
			    *maradektvp_parancs_next->parancs = '\0';
			}
			reformat_fordulo(fordulo, maradektvp_parancs->parancs);
			if (maradektvp_parancs_next)
			{
			    *maradektvp_parancs_next->parancs = ttmp;
			}
		    }
		}
		else
		{
		    reformat_fordulo(fordulo, *p1);
		}
	    }
	}
	else if (p1 == &fordulo->fejlec)
	{
	    csata_next(NULL, &fordulo->osszesen);
	    if (!get_cache_mode())
	    {
#ifdef DEBUG
		debug(fordulo, "fordulo reformat fejlec: %.100s\n", *p1);
#endif
		reformat_fejlec(fordulo, *p1);
	    }
	}
	else if (p1 == &fordulo->korvege_tvp)
	{
	    if (fordulo->tipus == fordulo_tipus_olimpia)
	    {
#ifdef DEBUG
	        debug(fordulo, "fordulo reformat olimpia eredmenyhirdetes\n");
#endif
		reformat_olimpia_korvege(fordulo, *p1);
	    }
	    else
	    {
#ifdef DEBUG
		debug(fordulo, "fordulo reformat korvege\n");
#endif
		reformat_korvege(fordulo, *p1);
	    }
	}
	else if (p1 == &fordulo->encek)
	{
#ifdef DEBUG
	    debug(fordulo, "fordulo reformat encek\n");
#endif
	    reformat_encek(fordulo, *p1);
	}
	else if (p1 == &fordulo->karlap)
	{
#ifdef DEBUG
	    debug(fordulo, "fordulo reformat karlap\n");
#endif
	    reformat_karlap(fordulo);
	}
	else if (p1 == &fordulo->end_eleje)
	{
	    if (!get_cache_mode())
	    {
#ifdef DEBUG
		debug(fordulo, "fordulo reformat end_eleje\n");
#endif
		reformat_else(fordulo, *p1);
	    }
	}
	else if (p1 == &fordulo->ref_szorny)
	{
#ifdef DEBUG
	    debug(fordulo, "fordulo reformat referencia szornyek\n");
#endif
	    reformat_referencia(fordulo, *p1);
	}
	else if (p1 == &fordulo->ref_targy)
	{
#ifdef DEBUG
	    debug(fordulo, "fordulo reformat referencia targyak\n");
#endif
	    reformat_referencia(fordulo, *p1);
	}
	else if (p1 == &fordulo->ktjelentes)
	{
	    if (!get_cache_mode())
	    {
#ifdef DEBUG
		debug(fordulo, "fordulo reformat ktjelentes\n");
#endif
		if (aconf_get_curr("reformat_ktjelentes") == 1)
		{
		    reformat_ktjelentes(fordulo, *p1);
		}
	    }
	}
	else if (p1 == &fordulo->terkep)
	{
#ifdef DEBUG
	    debug(fordulo, "fordulo reformat referencia terkep\n");
#endif
	    reformat_terkep(fordulo, *p1);
	}
	else
	{
	    if (!get_cache_mode())
	    {
#ifdef DEBUG
		debug(fordulo, "fordulo reformat else\n");
#endif
		reformat_else(fordulo, *p1);
	    }
	}
	
	**p2 = tmp;
    }
    if (!get_cache_mode())
    {
#ifdef DEBUG
	debug(fordulo, "fordulo reformat for utan\n");
#endif
	if (p1 = &fordulo->end)
	{
#ifdef DEBUG
	    output(fordulo,"\r\n<br><A NAME=#reformat><BR>%s Debuger &copy KWS, %s<BR></A>\r\n", VERSION, VST);
#else
	    output(fordulo,"\r\n<br><A NAME=#reformat><BR>%s &copy KWS, %s<BR></A>\r\n", VERSION, VST);
#endif
	    output(fordulo,"<A HREF=\"%s\" target=reformat>%s</A><BR>\r\n", REFORMAT_HYPERLINK, REFORMAT_HYPERLINK);
	    output(fordulo,"Kln ksznet Timnnak az els reformatrt, amibl minden kiindult, illetve Chaar-Lee-nak a clformatrt (ami ha ment volna linuxon, akkor nem irtam volna meg ezt :)\r\n<BR></BODY>\r\n</HTML>\r\n", VERSION);
	}
    }
    
    kiir(fordulo, " Done.\r\n");
    return 1;
}

extern int search_init(t_fordulo * fordulo)
{
    csataveg_init(fordulo);
    trezsor_init(fordulo);
    event_init(fordulo);
}
