/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#include "typedef.h"
#ifndef INCLUDED_FORMAT_TYPES
#define INCLUDED_FORMAT_TYPES

typedef enum
{
    encek_type_none,
    encek_type_szorny,
    encek_type_targy,
    encek_type_recept,
    encek_type_varazslat,
    encek_type_pszi,
    encek_type_tudati,
    encek_type_kepesseg
} t_encek_type;

typedef struct encek
{
    t_encek_type type;
    char * name;
} t_enc;

struct csata
{
    int fsz;
    t_fordulo * fordulo;
    char * block;
    char * eleje;
    char * neveleje;
    char * nevvege;
    char * vege_eleje;
    char * vege;
    int csataveg_i;
    long sebzes_utes;
    long sebzes_utes_beforr;
    long sebzes_egyeb;
    long sebzodes_utes;
    long sebzodes_egyeb;
    long vampiri;
    long nekrocsok;
    long mihlanil;
    long torpregen;
    long kobor;
    long vampirkt;
    long kreitonfozet;
    long feltamadas;
    long dem;
    long morgan_csata;
    long oregedes_csata;
    long papirang_csata;
    long varazstoltodes_vp;
    long trafo_vp;
    long trafo_ep;
    long kontakt_vp;
    long kontakt_pp;
    long ero;
    long iq;
    long ugyesseg;
    long egeszseg;
    long szerencse;
    long ep_p;
    long ep_n;
    long vp_p;
    long vp_n;
    long vp_koltes;
    long pszi_p;
    long pszi_n;
    long pszi_koltes;
    long tu_p;
    long tu_n;
    long tu_koltes;
    long tvp_p;
    long tvp_n;
    long tvp_kapas;
    long tvp_koltes;
    long vp_fno;
    long vp_stat_p;
    long vp_stat_n;
    long vp_max_p;
    long vp_max_n;
    long vp_manakristaly;
    long vp_varazsko;
    long tp_p;
    long tp_n;
    long ep_stat_p;
    long ep_stat_n;
    long ep_max_p;
    long ep_max_n;
    long pszi_stat_p;
    long pszi_stat_n;
    long pszi_max_p;
    long pszi_max_n;
    long tu_stat_p;
    long tu_stat_n;
    long tu_max_p;
    long tu_max_n;
    long tvp_stat_p;
    long tvp_stat_n;
    long tp_stat_p;
    long tp_stat_n;
    long jellem_stat_p;
    long jellem_stat_n;
    long jellem_csata_p;
    long jellem_csata_n;
    long kurt_stat_ep;
    long kurt_stat_vp;
    long morgan_stat;
    long oregedes_stat;
    long fiatalodas_stat;
    long papirang_stat_p;
    long papirang_stat_n;
    long ladiko_ap;
    long ladiko_ep;
    long unused_1;
    long unused_2;
    long unused_3;
    long unused_4;
    long unused_5;
    long unused_6;
    long unused_7;
    long unused_8;
    long unused_9;
    long unused_10;
    long unused_11;
    long unused_12;
    long unused_13;
    long unused_14;
    long unused_15;
    long unused_16;
    long egyeb_p;
    long egyeb_n;
};

#ifdef FORMAT_INTERNAL_ACCESS
#endif /* FORMAT_INTERNAL_ACCESS */

#endif

#ifndef JUST_NEED_TYPES
#ifndef INCLUDED_FORMAT_PROTOS
extern int reformat(t_fordulo * fordulo);
extern int referencia_check(t_fordulo * fordulo);
extern int search_init(t_fordulo * fordulo);
extern int stat_get_max(void);
#define INCLUDED_FORMAT_PROTOS
#endif
#endif
