/*
 * Copyright (C) 2003-2005  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#include "typedef.h"
#ifndef INCLUDED_KARAKTER_TYPES
#define INCLUDED_KARAKTER_TYPES

typedef struct faj 
{
    int szam;
    char * nev;
}
t_faj;

typedef struct papirang
{
    int szam;
    char * nev;
    int tol;
    int ig;
}
t_papirang;

typedef enum
{
    targy_flag_none = 0x0000,
    targy_flag_kf = 0x0001,
    targy_flag_hu = 0x0002,
} t_targy_flag;

typedef enum
{
    targy_hol_osszesen = 0,
    targy_hol_nalad = 1,
    targy_hol_bankban = 2
} t_targy_hol;

typedef struct karakter_targylist
{
    int ssz;
    t_targy * targy;
    int darab;
    int nalad;
    int bankban;
    t_targy_flag flag;
//    t_targy_figyelt * figyelt;
    struct karakter_targylist * next;
    int valtozas_checked;
} t_karakter_targylist;

typedef struct karakter_fegyverlist
{
    int ssz;
    t_fegyver * fegyver;
    struct karakter_fegyverlist * next;
} t_karakter_fegyverlist;

typedef struct karakter_spelllist
{
    int ssz;
    t_spell * spell;
    int fentvan;
    struct karakter_spelllist * next;
} t_karakter_spelllist;

struct fegyverszaki
{
    int okol;
    int szuro;
    int vago;
    int uto;
    int lo;
    int dobo;
    int vizi;
};

struct fno_skillek
{
    int sebzes;
    int tamadas;
    int vedekezes;
    int maxep;
    int varazslatsebzes;
    int regeneracio;
    int tno;
    int kno;
    int gyorsfejlodes;
    int vpregen;
    int kincskereses;
    int halhatatlansag;
    int targymento;
    int plusz_tp;
    int rezisztencia;
    int tulajdonsagpajzs;
    int magiaero;
};

struct kepessegek
{
    int rejtozkodes;
    int nyomkovetes;
    int lopas;
    int maszas;
    int csapdakeszites;
    int csapdaeszleles;
    int gyogyitas;
    int titkosiras;
    int felderites;
    int szornyidomitas;
    int teologia;
    int taumaturgia;
    int szerencsejatek;
    int versenges;
    int harcmuveszet;
    int szkander;
    int zene;
    int szornyismeret;
    int pszi;
    int zarnyitas;
    int vadaszat;
    int vitalitas;
    int banyaszat;
    int testepites;
    int uszas;
    int orditas;
    int fozes;
    int osteologia;
    int ostaumaturgia;
};

struct tulajdonsagok
{
    int ero;
    int ero_modositott;
    int iq;
    int iq_modositott;
    int ugyesseg;
    int ugyesseg_modositott;
    int egeszseg;
    int egeszseg_modositott;
    int szerencse;
    int szerencse_modositott;
    int maxtu;
    int tu;
    int maxep;
    int ep;
    int maxvp;
    int vp;
    int maxpp;
    int pp;
    int vedekezes;
    int vedekezes_modositott;
    int tamadas;
    int tamadas_modositott;
    int jellempont;
    int eletkor_alap;
    int eletkor_aktualis;
    int tno;
    int kno;
};

struct bonuszok
{
    int ero;
    int iq;
    int ugyesseg;
    int egeszseg;
    int szerencse;
    int maxtu;
    int maxep;
    int maxvp;
    int maxpp;
    int vedekezes;
    int tamadas;
    int sebzes;
    int vpreg;
};

typedef struct varazslatsebzes
{
    int ssz;
    int bonusz;
    int max;
    int maxteo;
    int maxtau;
    int van;
    t_targy_flag flag;
    t_targy * targy;
} t_varazslatsebzes;

struct karakter
{
    t_fordulo * fordulo;
    int ksz;
    int szint;
    char * karlapstart;
    char * tulajdonsag;
    char * fegyverszaki;
    char * ff;
    char * szakertelmek;
    char * fno;
    char * fparancs;
    char * spellek;
    char * spellrajtad;
    char * tvlista;
    char * elfogottszornyek;
    char * istenikuldi;
    char * hostett;
    char * reformat_jo_tudni;
    char * reformat_figyelemmel_kisert;
    char * reformat_tipusonkenti_bontas;
    char * reformat_varazslataid_sebzese;
    char * reformat_fegyvereid_sebzese;
    char * reformat_kihivas_torony;
    char * targylista;
    char * megterheltseg;
    char * bank;
    char * targyment;
    char * targyjott;
    char * karlapend;
    int dvk;
    int csupaszizom;
    int oriasero;
    int csupaszizom_van;
    int oriasero_van;
    int meditacio_van;
    int hadiszerencse;
    int eropajzs;
    int hatalomvarazs;
    int jellemero;
    int teoero;
    int tauero;
    int osteoero;
    int ostauero;
    int psziero;
    t_tulajdonsagok tulajdonsagok;
    t_bonuszok bonuszok;
    t_kepessegek kepessegek;
    t_kepessegek kepesseg_bonuszok;
    t_fno_skillek fno_skillek;
    int fnopont;
    int sebzes_pajzsbol;
    int sebzesbonusz_vizben;
    int butasagara_plusz_teo;
    int butasagara_hatar_teo;
    int butasagara_plusz_tau;
    int butasagara_hatar_tau;
    int plusz10vpregen;
    int nem;
    int faj;
    int arany;
    char jellem;
    int papirang;
    int papikarkoto;
    t_fegyverszaki fszaki;
    t_targy * targyak;
    int tleikan_targy_darab;
    int faji_kopeny;
    int ovsal;
    int gharitonfokusz;
    unsigned long targyak_erteke;
    unsigned long targyak_erteke_huban;
    unsigned long targyak_sulya;
    t_karakter_targylist * karakter_targylist_head;
    t_karakter_targylist * karakter_targylist_tail;
    t_karakter_targylist * karakter_targylist_bonusz_head;
    t_karakter_targylist * karakter_targylist_bonusz_tail;
    t_karakter_targylist * karakter_targylist_kepesseg_head;
    t_karakter_targylist * karakter_targylist_kepesseg_tail;
    t_karakter_targylist * karakter_targylist_spell_head;
    t_karakter_targylist * karakter_targylist_spell_tail;
    t_karakter_targylist * karakter_targylist_valtozas_head;
    t_karakter_targylist * karakter_targylist_valtozas_tail;
    t_karakter_spelllist * karakter_spelllist_head;
    t_karakter_spelllist * karakter_spelllist_tail;
    t_karakter_spelllist * karakter_spelllist_sebzo_head;
    t_karakter_spelllist * karakter_spelllist_sebzo_tail;
    t_karakter_fegyverlist * karakter_fegyverlist_head[7];
    t_karakter_fegyverlist * karakter_fegyverlist_tail[7];
    t_varazslatsebzes * varazslatsebzes;
    int varazslatsebzes_size;
    t_targy_figyelt * karakter_targy_figyelt_list_head;
    t_targy_figyelt * karakter_targy_figyelt_list_tail;
};

#define KARAKTER_TARGYLIST_NUM 4

#endif

#ifndef JUST_NEED_TYPES
#ifndef INCLUDED_KARAKTER_PROTOS
#define INCLUDED_KARAKTER_PROTOS
extern int karakter_init(t_fordulo * fordulo);
extern int karakter_deinit(t_fordulo * fordulo);
extern char * get_bonuszok_neve(int i);
extern char * get_kepessegek_neve(int i);
extern int karakter_targy_figyelt_init(t_karakter * karakter);
extern int karakter_targy_figyelt_add(t_karakter * karakter, int ssz, int min, int max);
extern t_targy_figyelt * karakter_targy_figyelt_check(t_karakter * karakter, int ssz);
extern int karakter_targy_figyelt_set_targylist(t_karakter * karakter, int ssz, t_karakter_targylist * karakter_targylist);
extern int karakter_targy_figyelt_list_destroy(t_karakter * karakter);
extern int karakter_targylista_figyelt_init(t_karakter * karakter);
extern int karakter_targylist_head_init(t_karakter * karakter);
extern t_karakter_targylist * get_karakter_targylist_head(t_karakter * karakter, int i);
extern int karakter_targylist_destroy(t_karakter * karakter);
extern int karakter_targylist_add(t_karakter * karakter, t_targy * targy, int darab, t_targy_flag flag, t_targy_hol hol);
extern int karakter_targylist_init(t_karakter * karakter);
extern int karakter_spelllist_head_init(t_karakter * karakter);
extern t_karakter_spelllist * get_karakter_spelllist_head(t_karakter * karakter, int i);
extern int karakter_spelllist_destroy(t_karakter * karakter);
extern int karakter_spelllist_add(t_karakter * karakter, t_spell * spell);
extern int karakter_spelllist_init(t_karakter * karakter);
extern int karakter_spelllist_init_fentvan(t_karakter * karakter);
extern int karakter_spelllist_set_fentvan(t_karakter * karakter, int ssz);
extern int karakter_spelllist_check_spell(t_karakter * karakter, int ssz);
extern int karakter_targylist_check_targy_osszerakas(t_karakter * karakter, int ssz);
extern int karakter_targylist_check_targy(t_karakter * karakter, int ssz);
extern int karakter_targylist_check_targy_nalad(t_karakter * karakter, int ssz);
extern int karakter_targylist_check_targy_kf(t_karakter * karakter, int ssz);
extern t_karakter_targylist * karakter_targylist_get_targy(t_karakter * karakter, int ssz);
extern int karakter_targylista_valtozas_check(t_karakter * karakter_mostani, t_karakter * karakter_elozo);
extern t_karakter_fegyverlist * get_karakter_fegyverlist_head(t_karakter * karakter, int i);
extern int karakter_fegyverlist_add_fegyver(t_karakter * karakter, t_targy * targy);
extern int karakter_fegyverlist_destroy(t_karakter * karakter);
extern int karakter_fegyverlist_head_init(t_karakter * karakter);
extern int kepesseg_id_from_hyper_id(int id);
#endif
#endif
