/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#define NOTES_INTERNAL_ACCESS
#include "include.h"
#include "notes.h"
#include "conf.h"


extern int notes(int ksz, int fsz, char * text, ...)
{
    va_list va;
    char filename[10];
    char * file;
    char * notesdir;
    FILE * fp;

    if ((ksz > 10000) || ksz < 1000)
    {
	return -1;
    }
    if (notesdir = bconf_get_notesdir())
    {
	sprintf(filename, "%d.not", ksz);
	file = get_filename(notesdir, filename);
	if (fp = fopen(file,"ab"))
	{
	    fprintf(fp, "%d_%d: ", ksz, fsz);
    	    va_start(va, text);
	    vfprintf(fp, text, va);
	    va_end(va);
	
	    fflush(fp);
	    fclose(fp);
	}

	free(file);
	return 1;
    }
    return 0;
}
