/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#define SEBZES_INTERNAL_ACCESS
#include "include.h"
#include "sebzes.h"


extern t_sebzes * sebzes_create(char * sebf)
{
    t_sebzes * sebzes = NULL;
    int ok;
    int elojel;
    char * p1;
    char * p2;
    
    if (sebzes = malloc(sizeof(t_sebzes)))
    {
	memset(sebzes,0,sizeof(t_sebzes));
	if (sebf)
	{
	    for (ok = 0, elojel = 0; 1; )
	    {
	        p1 = skip_space(sebf);
		for (p2 = p1; isdigit2(*p2) && (p2 < sebf + strlen(sebf)); p2++);
		p2 = skip_space(p2);
		if ((*p2 == 'd') || (*p2 == 'D'))
		{
		    if (p1 == p2)
		    {
			sebzes->darab = 1;
		    }
		    else if (isdigit2(*p1))
		    {
			sebzes->darab = atoi(p1);
		    }
		    else
		    {
			break;
		    }
		}
		else if ((p2 = sebf + strlen(sebf)) && isdigit2(*p1))
		{
		    sebzes->bonusz = atoi(p1);
		    ok = 1;
		    break;
		}
		else
		{
		    break;
		}
		p1 = skip_space(p2+1);
		for (p2 = p1; isdigit2(*p2) && (p2 < sebf + strlen(sebf)); p2++);
		if ((p1 != p2) && isdigit2(*p1))
		{
		    sebzes->ertek = atoi(p1);
		}
		else
		{
		    break;
		}
		
		p1 = skip_space(p2);
		for (p2 = p1; (*p2 != '+') && (*p2 != '-') && (p2 < sebf + strlen(sebf)); p2++);
		if (*p2 == '+')
		{
		    elojel = 1;
		}
		else if (*p2 == '-')
		{
		    elojel = -1;
		}
		else if (*p2 == '\0')
		{
		    ok = 1;
		    break;
		}
		
		p1 = skip_space(p2+1);
		if (!isdigit2(*p1))
		{
		    break;
		}
		sebzes->bonusz = elojel * atoi(p1);
		ok = 1;
		break;
	    }
	}
    }
    return sebzes;
}

extern float sebzes_calculate(t_sebzes sebzes)
{
    float ret;
    
    ret = (((float)sebzes.ertek + 1) * (float)sebzes.darab / 2 + (float)sebzes.bonusz);
    return ret;
}
