/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#include "typedef.h"
#ifndef INCLUDED_SPELL_TYPES
#define INCLUDED_SPELL_TYPES
#ifndef JUST_NEED_TYPES
# define JUST_NEED_TYPES
# include "karakter.h"
# include "sebzes.h"
# include "conf.h"
# undef JUST_NEED_TYPES
#else
# include "karakter.h"
# include "sebzes.h"
# include "conf.h"
#endif

typedef enum
{
    spell_type_none = 0x00000000,
    spell_type_villam = 0x00000001,
    spell_type_tuz = 0x00000002,
    spell_type_jeg = 0x00000004,
    spell_type_mereg = 0x00000008,
    spell_type_halal = 0x00000010,
    spell_type_nekrocsok = 0x00000020,
    spell_type_tau = 0x00001000,
    spell_type_teo = 0x00002000,
    spell_type_pszi = 0x00004000,
    spell_type_avk = 0x00008000,
    spell_type_ostau = 0x00010000,
    spell_type_osteo = 0x00020000
} t_spell_type;

typedef enum
{
    spell_mento_none = 0x0000,
    spell_mento_felezo = 0x0001,
    spell_mento_nullazo = 0x0002
} t_spell_mento;

struct spell
{
    int ssz;
    char * nev;
    t_spell_type type;
    t_spell_mento mento;
    t_sebzes sebzes;
    int maxero;
    int spechatas;
    struct spell * next;
    struct spell * backup;
};

typedef struct spell_pointers
{
    int ssz;
    t_spell * spell;
} t_spell_pointers;

struct spell_figyelt
{
    int ssz;
    t_confset confset;
    int irany;
    int fentvan;
    t_spell * spell;
     t_karakter_spelllist * spelllist;
    struct spell_figyelt * next;
};

#endif

#ifndef JUST_NEED_TYPES
#ifndef INCLUDED_SPELL_PROTOS
#define INCLUDED_SPELL_PROTOS
#include "conf.h"
extern int spell_get_max(void);
extern t_spell_figyelt * get_spell_figyelt_head(void);
extern int spell_figyelt_init(int ssz);
extern int spell_figyelt_check(int ssz);
extern int spell_figyelt_add(int ssz, t_confset confset, int irany);
extern int spell_figyelt_del_confset(t_confset confset);
extern int spell_figyelt_destroy(void);
extern int spell_figyelt_set_spelllist(int ssz, t_karakter_spelllist * karakter_spelllist);
extern int spell_figyelt_set_fentvan(int ssz);
extern char * get_spelltipus_neve(int i);
extern t_spell * get_spell_from_ssz(int ssz);
extern t_spell * get_spell_head(void);
extern t_spell * spell_create(int ssz, char * nev, t_spell_type type, int maxero, int x, int y, int z, t_spell_mento mento);
extern int spell_list_add_spell(int ssz, char * nev, t_spell_type type, int maxero, int x, int y, int z, t_spell_mento mento);
extern t_spell_type spell_get_type_from_char(char c);
extern int spell_list_destroy(void);
extern spellek_spelllista_check(t_fordulo * fordulo);
extern int init_spell(char * filename);
#endif
#endif
