/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#define STR_INTERNAL_ACCESS
#include "include.h"
#include "str.h"
#include "fordulo.h"

static char sort_tab[] = "abcdefghijklmnopqrstuvwxyz";

extern int get_sort_index_from_char(char c)
{
    char * p;
    int k = 0;

    c = tolower2(c);
    if (p = strchr(sort_tab, (int)c))
    {
	k = p - sort_tab + 1;
	if ((k < 0) || (k > strlen(sort_tab)))
	{
	    k = 0;
	}
    }

    return k;
}

extern int strcmp_(char * s1, char * s2)
{
    int i, h;
    int n, m;
    int r, q;
    
    n = strlen(s1);
    m = strlen(s2);
//debug(NULL, "strcmp_: %d \"%s\"\n",n,s1);
//debug(NULL, "strcmp_: %d \"%s\"\n",m,s2);
    r = 0;
    q = 0;
    h = n;

    if (n != m)
    {
	if (n > m)
	{
	    q = 1;
	    h = m;
	}
	else
	{
	    q = -1;
	    h = n;
	}
    }
//kiir(NULL, "A");    
    i = 0;
    while(i <= h)
    {
//debug(NULL, "strcmp_: %d/%d/%+d\n",h,i,memcmp(s1, s2, i));
//	if (memcmp(s1, s2, i+1) != 0)
	if (tolower2(s1[i]) != tolower2(s2[i]))
	{
//debug(NULL, "strcmp_: break\n");
	    break;
	}
	i++;
    }
//kiir(NULL, "B");    
    
    if (i > h)
    {
	return q;
    }
    
    r = get_sort_index_from_char(s1[i]) - get_sort_index_from_char(s2[i]);
    
    return r;
}

extern char * skip_space(char * s)
{
    if (!s)
    {
	return NULL;
    }
    for ( ; (*s != '\0') && ((*s == ' ') || (*s == '\t') || (*s == '\r') || (*s == '\n')); s++);
    return s;
}

extern char * skip_nonspace(char * s)
{
    if (!s)
    {
	return NULL;
    }
    for ( ; (*s != '\0') && (*s != ' ') && (*s != '\t') && (*s != '\r') && (*s != '\n'); s++);
    return s;
}

extern int isspace2(unsigned char c)
{
    if ((_strtab[c] & _S) != 0)
    {
	return 1;
    }
    
    return 0;
}

extern int isdigit2(unsigned char c)
{
    if ((_strtab[c] & _D) != 0)
    {
	return 1;
    }
    
    return 0;
}

extern int islower2(unsigned char c)
{
    if ((_strtab[c] & _L) != 0)
    {
	return 1;
    }
    
    return 0;
}

extern int isupper2(unsigned char c)
{
    if ((_strtab[c] & _U) != 0)
    {
	return 1;
    }
    
    return 0;
}

extern unsigned char tolower2(unsigned char c)
{
    if ((_strtab[c] & _U) != 0)
    {
	c -= 'A'-'a';
	
    }
    return c;
}

extern unsigned char toupper2(unsigned char c)
{
    if ((_strtab[c] & _L) != 0)
    {
	c += 'A'-'a';
	
    }
    return c;
}

extern int str_tolower2(char * s)
{
    unsigned long n;
    unsigned long i;
    
    n = strlen(s);
    i = 0;
    while (i < n)
    {
	s[i] = tolower2(s[i]);
	i++;
    }
}

extern int str_toupper2(char * s)
{
    unsigned long n;
    unsigned long i;
    
    n = strlen(s);
    i = 0;
    while (i < n)
    {
	s[i] = toupper2(s[i]);
	i++;
    }
}

extern int str_htm2txt(char * s)
{
    unsigned long n;
    unsigned long i, j;
    int skip;
    
    n = strlen(s);
    
    for (skip = 0, i = 0, j = 0; i < n ; i++)
    {
	if (s[i] == '<')
	{
	    skip = 1;
	    continue;
	}
	else if (s[i] == '>')
	{
	    skip = 0;
	    continue;
	}
	else if ((s[i] == '\n') || (s[i] == '\r') || (s[i] == '\t'))
	{
	    continue;
	}
	if (skip)
	{
	    continue;
	}
	s[j++] = s[i];
    }
    s[j] = '\0';
}

extern char * get_filename(char * dir, char * file)
{
    int kell;
    char * p;
    char sep;
    
    if (!file)
    {
	return NULL;
    }
    else if (!dir)
    {
	p = strdup(file);
	return p;
    }

#ifdef DEBUG
    debug(NULL, "get_filename: dir=\"%s\" file=\"%s\"\n", dir, file);
#endif

#ifndef WIN32    
    sep = '/';
#else
    sep = '\\';
#endif
    if (strrchr(dir, '/'))
    {
        sep = '/';
    }
    else if (strrchr(dir, '\\'))
    {
        sep = '\\';
    }
    
    if ((file[0] == sep) || ((file[2] == sep) && (file[1] == ':')) || ((file[1] == sep) && (file[0] == '.')))
    {
	p = strdup(file);
        return p;
    }
    if (dir[strlen(dir)-1] == sep)
    {
        kell = 0;
    }
    else
    {
        kell = 1;
    }
    
    if (p = malloc(strlen(dir) + kell + strlen(file) + 1))
    {
        if (kell)
        {
    	    sprintf(p, "%s%c%s", dir, sep, file);
	}
	else
	{
	    sprintf(p, "%s%s", dir, file);
	}
    }
    
#ifdef DEBUG
    debug(NULL, "get_filename: p=\"%s\" (%d)\n", p, strlen(p));
#endif
    return p;
}

extern int parancs_check(t_fordulo * fordulo, char * s)
{
    int ret = 0;
    
    if (fordulo->p && (strlen(fordulo->p) > strlen(s)))
    {
	if ((strncmp(fordulo->p, s, strlen(s)) == 0) && (fordulo->p[strlen(s)] == ' '))
	{
	    ret = 1;
	}
    }
    return ret;
}

/*
// strstr implementaciok
char * strstri1(const char * s1,const char * s2)
{
	int l1, l2;

	l2 = strlen(s2);
	if (!l2)
		return (char *) s1;
	l1 = strlen(s1);
	while (l1 >= l2) {
		l1--;
		if (!memcmp(s1,s2,l2))
			return (char *) s1;
		s1++;
	}
	return NULL;
}

char * strstri2(const char * cs,const char * ct)
{
int	d0, d1;
register char * __res;
__asm__ __volatile__(
	"movl %6,%%edi\n\t"
	"repne\n\t"
	"scasb\n\t"
	"notl %%ecx\n\t"
	"decl %%ecx\n\t"	// NOTE! This also sets Z if searchstring=''
	"movl %%ecx,%%edx\n"
	"1:\tmovl %6,%%edi\n\t"
	"movl %%esi,%%eax\n\t"
	"movl %%edx,%%ecx\n\t"
	"repe\n\t"
	"cmpsb\n\t"
	"je 2f\n\t"		// also works for empty string, see above
	"xchgl %%eax,%%esi\n\t"
	"incl %%esi\n\t"
	"cmpb $0,-1(%%eax)\n\t"
	"jne 1b\n\t"
	"xorl %%eax,%%eax\n\t"
	"2:"
	:"=a" (__res), "=&c" (d0), "=&S" (d1)
	:"0" (0), "1" (0xffffffff), "2" (cs), "g" (ct)
	:"dx", "di");
return __res;
}
*/

extern char * strstr2(char * miben, char * mit)
{
    char * p = NULL;

    if( miben == NULL || mit == NULL)
    {
        return NULL;
    }

    if(p = strstr(miben, mit))
    {
        return (p + strlen(mit));
    }
    else
    {
        return NULL;
    }
}

extern char * strstr_(char * miben, char * mit, char * meddig)
{
    strstrx_i(miben, mit, meddig, 0, 1, NULL, NULL);
}

extern char * strstr_i(char * miben, char * mit, char * meddig)
{
    strstrx_i(miben, mit, meddig, 1, 1, NULL, NULL);
}

extern char * strstr2_(char * miben, char * mit, char * meddig)
{
    strstrx_i(miben, mit, meddig, 0, 2, NULL, NULL);
}

extern char * strstr2_i(char * miben, char * mit, char * meddig)
{
    strstrx_i(miben, mit, meddig, 1, 2, NULL, NULL);
}

extern char * strstr3_(char * miben, char * mit, char * meddig, char ** eleje, char ** vege)
{
    strstrx_i(miben, mit, meddig, 0, 3, eleje, vege);
}

extern char * strstr3_i(char * miben, char * mit, char * meddig, char ** eleje, char ** vege)
{
    strstrx_i(miben, mit, meddig, 1, 3, eleje, vege);
}

extern char * strstr4_(char * miben, char * mit, char * meddig, char ** eleje, char ** vege)
{
    strstrx_i(miben, mit, meddig, 0, 4, eleje, vege);
}

extern char * strstr4_i(char * miben, char * mit, char * meddig, char ** eleje, char ** vege)
{
    strstrx_i(miben, mit, meddig, 1, 4, eleje, vege);
}

// Atugorja a kovetkezo karaktereket: \n \r \t [space]
// Ha insensitive = 0 case sensitive, ha insensitive = 1 case insensitive
// Ha pozicio = 1, a visszaadott pointer eleje, ha pozicio = 2, a visszaadott pointer a vege
// ha a pozicio = 3 a visszadott pointer a vege, ES az eleje es a vege is beallitasra kerul
// ha a pozicio = 4 a visszadott pointer az eleje, ES az eleje es a vege is beallitasra kerul
extern char * strstrx_i(char * miben, char * mit, char * meddig, int insensitive, int pozicio, char ** eleje, char ** vege)
{
    char * p1;
    char * p2;
    char * p1_end;
    char * p2_end;
    char * token2;
    char * str2;
    int n1;
    int n2;
    int ok;
    char * ret;
    char * x1;
    char * x2;
    int i;
    
    if(miben == NULL || mit == NULL) 
    {
	return NULL;
    }
    
    n2 = strlen(mit);
    ok = 0;
    ret = NULL;
    x1 = NULL;
    x2 = NULL;
    
#ifdef DEBUG_STR
    debug(NULL, "strstrx_i miben: --->1:%.60s<---\n", miben);
    debug(NULL, "strstrx_i mit  : --->2:%.60s<---\n", mit);
//    debug(NULL, "strcmp=%d\n",strcmp( miben, mit));
#endif
    if (strcmp(miben, mit) == 0)
    {
	return (miben+strlen(miben));
    }
    if (str2 = malloc(n2+1))
    {
#ifdef DEBUG_STR
//debug(NULL, "strstrx_i1\n");
#endif
	memset(str2,0,n2+1);
	strcpy(str2,mit);
	
	if (token2 = strtok(str2, " "))
	{
#ifdef DEBUG_STR
	    debug(NULL, "strstrx_i2: %s\n", token2);
#endif
	    n1 = strlen(token2);
	    if (n1 < n2)
	    {
		token2[n1] = ' ';
		token2[n1+1] = '\0';
	    }
	    p1 = miben;
	    p1_end = p1 + strlen(miben);
#ifdef DEBUG_STR
	    debug(NULL, "strstrx_i2a: ok=%i, \"%.10s\", p1=%p, p1_end=%p\n", ok, strstr(p1+1,token2), p1, p1_end);
#endif
	    if (meddig && (meddig > p1) && (meddig < p1_end))
	    {
		p1_end = meddig;
	    }
#ifdef DEBUG_STR
	    debug(NULL, "strstrx_i3: |%.160s|%s|\n",p1+1,token2);
#endif
	    p2 = mit + (token2 - str2);
	    p2_end = p2 + strlen(p2);
#ifdef DEBUG_STR
	    debug(NULL, "strstrx_i3a: ok=%d, *p1=%.1s, *p2=%.1s, p1=%p, p1_end=%p, p2=%p, p2_end=%p, strstr=%p\n",ok,p1, p2, p1, p1_end, p2, p2_end, strstr(p1,token2));
#endif
	    p1--;
	    while ((ok == 0) && (p1 = strstr(p1+1,token2)) && (p1 < p1_end))
	    {
		x1 = p1;
		p2 = mit + (token2 - str2);
#ifdef DEBUG_STR
		debug(NULL, "strstrx_i4: \"%.60s\", \"%.60s\"\nstrstrx_i5: p1=%p, p1_end=%p, p2=%p, p2_end=%p\n", p1, p2, p1, p1_end, p2, p2_end);
#endif
		for (i = 1, ok = 1; p2 < p2_end && p1 < p1_end; p1++, p2++, i++)
		{
#ifdef DEBUG_STR
		    debug(NULL, "strstrx_i4a: |%.60s|%.60s\n",p1,p2);
#endif
		    for ( ; (*p1 == '\n') || (*p1 == '\r') || (*p1 == '\t') || (*p1 == ' '); p1++);
		    for ( ; (*p2 == '\n') || (*p2 == '\r') || (*p2 == '\t') || (*p2 == ' '); p2++);
		    if (insensitive)
		    {
			if(tolower2(*p1) != tolower2(*p2))
			{
#ifdef DEBUG_STR
			    debug(NULL, "strstrx_i5: *p1 != *p2, *p1=%.1s [%hhu], *p2=%.1s [%hhu], p2=%p, p2_end=%p\n", p1, *p1, p2, *p2, p2, p2_end);
#endif
			    ok = 0;
			    break;
			}
		    }
		    else
		    {
			if(*p1 != *p2)
			{
#ifdef DEBUG_STR
			    debug(NULL, "strstrx_i6: *p1 != *p2, *p1=%.1s, *p2=%.1s, p2=%p, p2_end=%p\n",p1, p2, p2, p2_end);
#endif
			    ok = 0;
			    break;
			}
		    }
		}
#ifdef DEBUG_STR
		debug(NULL, "strstrx_i7: %i, p2=%p, p2_end=%p, p1=\"%.20s\"\n",ok, p2, p2_end, p1);
#endif
		x2 = p1;
	    }
#ifdef DEBUG_STR
	    debug(NULL, "strstrx_i8: %i, p2=%p, p2_end=%p, x2=\"%.20s\"\n",ok, p2, p2_end, x2);
#endif
	    if ((ok == 1) && (p2 == p2_end))
	    {
		if (pozicio == 1)
		{
		    ret = x1;
		}
		else if (pozicio == 2)
		{
		    ret = x2;
		}
		else if (pozicio == 3)
		{
		    *eleje = x1;
		    *vege = x2;
		    ret = x2;
		}
		else if (pozicio == 4)
		{
		    *eleje = x1;
		    *vege = x2;
		    ret = x1;
		}
	    }

	}

	free(str2);
    }
#ifdef DEBUG_STR
    debug(NULL, "strstrx_i9: --->%.20s<---\n", ret);
#endif
    return ret;
}
