/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#include "typedef.h"
#ifndef INCLUDED_STR_TYPES
#define INCLUDED_STR_TYPES

#ifdef STR_INTERNAL_ACCESS
#define _U      0x01    /* upper */
#define _L      0x02    /* lower */
#define _D      0x04    /* digit */
#define _C      0x08    /* cntrl */
#define _P      0x10    /* punct */
#define _S      0x20    /* white space (space/lf/tab) */
#define _X      0x40    /* hex digit */
#define _SP     0x80    /* hard space (0x20) */
unsigned char _strtab[] = 
{
_C,_C,_C,_C,_C,_C,_C,_C,                        /* 0-7 */
_C,_C|_S,_C|_S,_C|_S,_C|_S,_C|_S,_C,_C,         /* 8-15 */
_C,_C,_C,_C,_C,_C,_C,_C,                        /* 16-23 */
_C,_C,_C,_C,_C,_C,_C,_C,                        /* 24-31 */
_S|_SP,_P,_P,_P,_P,_P,_P,_P,                    /* 32-39 */
_P,_P,_P,_P,_P,_P,_P,_P,                        /* 40-47 */
_D,_D,_D,_D,_D,_D,_D,_D,                        /* 48-55 */
_D,_D,_P,_P,_P,_P,_P,_P,                        /* 56-63 */
_P,_U|_X,_U|_X,_U|_X,_U|_X,_U|_X,_U|_X,_U,      /* 64-71 */
_U,_U,_U,_U,_U,_U,_U,_U,                        /* 72-79 */
_U,_U,_U,_U,_U,_U,_U,_U,                        /* 80-87 */
_U,_U,_U,_P,_P,_P,_P,_P,                        /* 88-95 */
_P,_L|_X,_L|_X,_L|_X,_L|_X,_L|_X,_L|_X,_L,      /* 96-103 */
_L,_L,_L,_L,_L,_L,_L,_L,                        /* 104-111 */
_L,_L,_L,_L,_L,_L,_L,_L,                        /* 112-119 */
_L,_L,_L,_P,_P,_P,_P,_C,                        /* 120-127 */
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,                /* 128-143 */
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,                /* 144-159 */
_S|_SP,_P,_P,_P,_P,_P,_P,_P,_P,_P,_P,_P,_P,_P,_P,_P,   /* 160-175 */
_P,_P,_P,_P,_P,_P,_P,_P,_P,_P,_P,_P,_P,_P,_P,_P,       /* 176-191 */
_U,_U,_U,_U,_U,_U,_U,_U,_U,_U,_U,_U,_U,_U,_U,_U,       /* 192-207 */
_U,_U,_U,_U,_U,_U,_U,_P,_U,_U,_U,_U,_U,_U,_U,_L,       /* 208-223 */
_L,_L,_L,_L,_L,_L,_L,_L,_L,_L,_L,_L,_L,_L,_L,_L,       /* 224-239 */
_L,_L,_L,_L,_L,_L,_L,_P,_L,_L,_L,_L,_L,_L,_L,_L};      /* 240-255 */
#endif /* STR_INTERNAL_ACCESS */
#endif

#ifndef JUST_NEED_TYPES
#ifndef INCLUDED_STR_PROTOS
extern int strcmp_(char * s1, char * s2);
extern char * skip_space(char * s);
extern char * skip_nonspace(char * s);
extern int isspace2(unsigned char c);
extern int isdigit2(unsigned char c);
extern int islower2(unsigned char c);
extern int isupper2(unsigned char c);
extern unsigned char tolower2(unsigned char c);
extern unsigned char toupper2(unsigned char c);
extern int str_tolower2(char * s);
extern int str_toupper2(char * s);
extern int str_htm2txt(char * s);
extern char * get_filename(char * dir, char * file);
extern int parancs_check(t_fordulo * fordulo, char * s);
extern char * strstr2(char * miben, char * mit);
extern char * strstr_(char * miben, char * mit, char * meddig);
extern char * strstr_i(char * miben, char * mit, char * meddig);
extern char * strstr2_(char * miben, char * mit, char * meddig);
extern char * strstr2_i(char * miben, char * mit, char * meddig);
extern char * strstr3_(char * miben, char * mit, char * meddig, char ** eleje, char ** vege);
extern char * strstr3_i(char * miben, char * mit, char * meddig, char ** eleje, char ** vege);
extern char * strstrx_i(char * miben, char * mit, char * meddig, int insensitive, int pozicio, char ** eleje, char ** vege);
#define INCLUDED_STR_PROTOS
#endif
#endif
