/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#include "typedef.h"
#ifndef INCLUDED_TARGY_TYPES
#define INCLUDED_TARGY_TYPES
#ifndef JUST_NEED_TYPE
# define JUST_NEED_TYPE
# include "karakter.h"
# include "conf.h"
# undef JUST_NEED_TYPE
#else
# include "karakter.h"
# include "conf.h"
#endif

#define TARGY_OSSZERAKHATO_MAX_RESZ 6

typedef enum
{
    targy_tipus_none = 0,
    targy_tipus_szuro = 1,
    targy_tipus_vago = 2,
    targy_tipus_uto = 3,
    targy_tipus_lo = 4,
    targy_tipus_dobo = 5,
    targy_tipus_vizi = 6,
    targy_tipus_pancel = 7,
    targy_tipus_pajzs = 8,
    targy_tipus_sisak = 9,
    targy_tipus_kesztyu = 10,
    targy_tipus_csizma = 11,
    targy_tipus_gyuru = 12,
    targy_tipus_kopeny = 13,
    targy_tipus_karkoto = 14,
    targy_tipus_fulbevalo = 15,
    targy_tipus_nadrag = 16,
    targy_tipus_vallvedo = 17,
    targy_tipus_uszogatya = 18,
    targy_tipus_ov = 19,
    targy_tipus_nyaklanc = 20,
    targy_tipus_kulcs = 21,
    targy_tipus_varazsital = 22,
    targy_tipus_lofegyver_lovedek = 23,
    targy_tipus_tarto = 24,
    targy_tipus_orokkevalosag_ekszer = 25,
    targy_tipus_esthar = 1001, 
    targy_tipus_boadhun = 1002, 
    targy_tipus_kyorg = 1003, 
    targy_tipus_arnytunde = 1004,
    targy_tipus_faji_targy = 1005,
    targy_tipus_cirkusz = 1006,
    targy_tipus_ejfatty_szarmazek = 1007,
    targy_tipus_ejfatty_esszencia = 1008,
    targy_tipus_ejfatty_targy = 1009,
    targy_tipus_moa = 1010,
    targy_tipus_ryuku = 1011
} t_targy_tipus;

typedef struct targy_alkoto
{
    int ssz;
    int darab;
    struct targy_alkoto * next;
} t_targy_alkoto;

struct targy
{
    int ssz;
    char * nev;
    t_targy_tipus tipus;
    t_targy_tipus tipus2;
    int minsz;
    int suly;
    int ea;
    int ve;
    int nonkf;
    int nonslot;
    t_targy_alkoto * alkoto;
    t_targy_alkoto * eszkoz;
    t_bonuszok * bonuszok;
    t_kepessegek * kepessegek;
    t_fegyver * fegyver;
    t_spell * spell;
    struct targy * next;
};

typedef struct targy_pointers
{
    int ssz;
    t_targy * targy;
} t_targy_pointers;

struct targy_figyelt
{
    int ssz;
    t_confset confset;
    int min;
    int max;
    t_targy * targy;
    t_karakter_targylist * targylist;
    struct targy_figyelt * next;
};

typedef struct targy_tomb
{
    int ssz;
    char * nev;
    int tipus;
    int minsz;
    int suly;
    int ea;
    int ve;
    int minfv;
    int magikus;
    int ezust;
    int balkez;
    int nonkf;
    int nonslot;
    char * sebf;
    char * alkoto;
    char * eszkoz;
    t_bonuszok bonuszok;
    t_kepessegek kepessegek;
    int spell;
    int fvari;
    int fvari_ero;
    int fvari_esely;
} t_targy_tomb;

#endif

#ifndef JUST_NEED_TYPES
#ifndef INCLUDED_TARGY_PROTOS
#define INCLUDED_TARGY_PROTOS
#include "conf.h"
extern t_targy_figyelt * get_targy_figyelt_head(void);
extern t_targy_figyelt * targy_figyelt_create(int ssz, t_confset confset, int min, int max);
extern int targy_figyelt_add(t_karakter* karakter, int ssz, t_confset confset, int min, int max);
extern int targy_figyelt_del_confset(t_confset confset);
extern int targy_figyelt_destroy(void);
extern char * get_tipusok_neve(int i);
extern t_targy * get_targy_from_ssz(int ssz);
extern int targy_head_init(void);
extern t_targy * get_targy_head(void);
extern int targy_list_destroy(void);
//extern int targyak_targylista_check_init(t_fordulo * fordulo);
extern int targyak_targylista_check(t_fordulo * fordulo);
extern int init_targy(char * filename);

extern t_targy * targy_create(int ssz, char * nev, t_targy_tomb * t);
extern int targy_list_add_targy(int ssz, char * nev, t_targy_tomb * t);

extern int targy_get_max(void);

extern int targy_check_faj(t_karakter * karakter, int ssz);
extern int targy_ad_bonuszt_vizben(t_targy * targy);

#endif
#endif
