/*
 * Copyright (C) 2003  Vizi Gabor (vizi@csucs.net)
 *
 * Ez az adatallomany a reformat program forraskodjanak resze.
 *
 * A program hasznalata, masolasa, terjesztese maganszemely 
 * bevetelt nem eredmenyezo celjara az eredeti forras, 
 * a szerzoi jogi megjegyzes es a hasznalati feltetelek 
 * feltuntetesevel es valtozatlanul hagyasaval, szabadon lehetseges. 
 * A program minden garancia nelkul kerul kozreadasra, a program
 * mukodesebol fakado osszes kockazat a felhasznalot terheli. 
 */
#define TORONY_INTERNAL_ACCESS
#include "include.h"
#include "torony.h"
#include "fordulo.h"
#include "karakter.h"
#include "cache.h"
#include "targy.h"
#include "conf.h"

static char * szakertelem_nevek[] =
{
    "szerencsejtk",
    "titkosirs",
    "zrnyits",
    "bnyszat",
    "csapdaszlels",
    "mszs",
    "szrnyidomits",
    "szrnyismeret",
    "zene",
    "felderits",
    "harcmvszet",
    "pszi",
    "vadszat",
    "gygyits",
    "lops",
    "rejtzkds",
    NULL
};

static t_probak PROBAK[]=
{
    "Szak", proba_szakertelem, 30, esely_calculate_szakertelem,
    "Info", proba_info, 20, esely_calculate_info,
    "Oles", proba_oles, 30, esely_calculate_oles,
    "Kesz", proba_keszites, 20, esely_calculate_keszites
};

static t_proba * proba_conf = (t_proba *)&PROBAK;

static t_proba_szint proba_szintek[]=
{
    {1,1,2,0,0,0,0,0,0},
    {1,2,2,3,0,0,0,0,0},
    {1,2,2,3,3,0,0,0,0},
    {1,2,2,3,3,3,0,0,0},
    {2,2,3,3,3,3,0,0,0},
    {1,1,2,2,3,3,0,0,0},
    {1,1,2,2,3,3,0,0,0},
    {1,1,1,2,2,2,3,3,3}
};

static t_proba * A = NULL;
static t_proba * B = NULL;
static t_proba * C = NULL;
static t_proba * D = NULL;

static t_lefutas lefutas[] =
{
    {&A, &B, &C, &A, &B, &C, &A, &B, &C},
    {&A, &B, &C, &D, &A, &B, &C, &A, &B},
    {&A, &B, &C, &A, &D, &B, &A, &C, &B},
    {&A, &B, &C, &D, &B, &A, &C, &B, &A},
    {&A, &B, &C, &A, &B, &D, &A, &B, &C},
    {&A, &B, &C, &D, &A, &C, &B, &A, &C},
    {&A, &B, &C, &A, &D, &C, &A, &B, &C},
    {&A, &B, &C, &D, &B, &C, &A, &B, &C},
    {&A, &B, &C, &A, &B, &C, &D, &A, &B},
    {&A, &B, &C, &D, &A, &B, &D, &A, &B},
    {&A, &B, &C, &A, &D, &B, &C, &A, &B},
    {&A, &B, &C, &D, &B, &A, &D, &B, &A},
    {&A, &B, &C, &A, &B, &D, &C, &A, &B},
    {&A, &B, &C, &D, &A, &C, &D, &A, &B},
    {&A, &B, &C, &A, &D, &C, &B, &A, &C},
    {&A, &B, &C, &D, &B, &C, &D, &A, &B},
    {&A, &B, &C, &A, &B, &C, &A, &D, &B},
    {&A, &B, &C, &D, &A, &B, &C, &D, &A},
    {&A, &B, &C, &A, &D, &B, &A, &D, &B},
    {&A, &B, &C, &D, &B, &A, &C, &D, &A},
    {&A, &B, &C, &A, &B, &D, &A, &C, &B},
    {&A, &B, &C, &D, &A, &C, &B, &D, &A},
    {&A, &B, &C, &A, &D, &C, &A, &D, &B},
    {&A, &B, &C, &D, &B, &C, &A, &D, &B},
    {&A, &B, &C, &A, &B, &C, &D, &B, &A},
    {&A, &B, &C, &D, &A, &B, &D, &C, &A},
    {&A, &B, &C, &A, &D, &B, &C, &D, &A},
    {&A, &B, &C, &D, &B, &A, &D, &C, &A},
    {&A, &B, &C, &A, &B, &D, &C, &B, &A},
    {&A, &B, &C, &D, &A, &C, &D, &B, &A},
    {&A, &B, &C, &A, &D, &C, &B, &D, &A},
    {&A, &B, &C, &D, &B, &C, &D, &B, &A},
    {&A, &B, &C, &A, &B, &C, &A, &B, &D},
    {&A, &B, &C, &D, &A, &B, &C, &A, &D},
    {&A, &B, &C, &A, &D, &B, &A, &C, &D},
    {&A, &B, &C, &D, &B, &A, &C, &B, &D},
    {&A, &B, &C, &A, &B, &D, &A, &B, &D},
    {&A, &B, &C, &D, &A, &C, &B, &A, &D},
    {&A, &B, &C, &A, &D, &C, &A, &B, &D},
    {&A, &B, &C, &D, &B, &C, &A, &B, &D},
    {&A, &B, &C, &A, &B, &C, &D, &A, &C},
    {&A, &B, &C, &D, &A, &B, &D, &A, &C},
    {&A, &B, &C, &A, &D, &B, &C, &A, &D},
    {&A, &B, &C, &D, &B, &A, &D, &B, &C},
    {&A, &B, &C, &A, &B, &D, &C, &A, &D},
    {&A, &B, &C, &D, &A, &C, &D, &A, &C},
    {&A, &B, &C, &A, &D, &C, &B, &A, &D},
    {&A, &B, &C, &D, &B, &C, &D, &A, &C},
    {&A, &B, &C, &A, &B, &C, &A, &D, &C},
    {&A, &B, &C, &D, &A, &B, &C, &D, &B},
    {&A, &B, &C, &A, &D, &B, &A, &D, &C},
    {&A, &B, &C, &D, &B, &A, &C, &D, &B},
    {&A, &B, &C, &A, &B, &D, &A, &C, &D},
    {&A, &B, &C, &D, &A, &C, &B, &D, &C},
    {&A, &B, &C, &A, &D, &C, &A, &D, &C},
    {&A, &B, &C, &D, &B, &C, &A, &D, &C},
    {&A, &B, &C, &A, &B, &C, &D, &B, &C},
    {&A, &B, &C, &D, &A, &B, &D, &C, &B},
    {&A, &B, &C, &A, &D, &B, &C, &D, &B},
    {&A, &B, &C, &D, &B, &A, &D, &C, &B},
    {&A, &B, &C, &A, &B, &D, &C, &B, &B},
    {&A, &B, &C, &D, &A, &C, &D, &B, &C},
    {&A, &B, &C, &A, &D, &C, &B, &D, &C},
    {&A, &B, &C, &D, &B, &C, &D, &B, &C}
};
static int lefutas_sorok[]= {1, 2, 4, 8 ,8, 1, 1, 64};

static int szornylista_1[]= {243, 203, 144, 154, 177, 151, 202, 216, 147, 146, 170, 153, 187, 156, 173, 189, 180};
static int szornylista_2[]= {222, 165, 166, 184, 232, 168, 164, 250, 171, 214, 248, 223, 191, 212, 241, 161, 251};
static int szornylista_3[]= {228, 205, 254, 235, 247, 227, 237, 224, 226, 159, 238, 229, 255, 256, 160, 231, 230};
static t_szorny_oles * szorny_oles_lista = NULL;

static int infolista_targy1[] = {420, 261, 84, 418, 419, 192, 390, 410, 381, 207, 119, 360, 254, 142, 196, 145, 143};
static int infolista_targy2[] = {61, 480, 350, 283, 374, 501, 62, 59, 349, 279, 442, 438, 337, 241, 285, 318, 417, 475};
static int infolista_targy3[] = {468, 472, 478, 369, 454, 527, 500, 388, 471, 321, 215, 316, 426, 292, 286, 485, 462, 412};

static int infolista_szorny1[] = {87, 93, 125, 135, 107, 21, 106, 40, 39, 36, 75, 171, 37};
static int infolista_szorny2[] = {203, 204, 205, 206, 207, 208, 209, 210, 211, 212, 213, 214, 215, 216, 127, 161};
static int infolista_szorny3[] = {35, 243, 233, 236, 207, 179, 216, 219, 41, 244, 254, 235, 247, 252, 237, 127, 246, 250, 238, 255, 182, 253, 248, 242, 239, 245, 240, 223, 249, 256, 241, 161, 251};

static t_targy_keszites targykeszites_1[] = 
{
    {  7}, { 10}, { 23}, { 34}, { 39}, { 72}, { 73}, {108}, {126}, {129}, {187}, {188}, {190}, {221}, {233}, {234}, {408}, {414}
};
static t_targy_keszites targykeszites_2[] = 
{
    { 49}, {107}, {165}, {174}, {176}, {182}, {189}, {242}, {249}, {255}, {322}, {323}, {327}, {336}, {338}, {351}, {407}, {430}
};
static t_targy_keszites targykeszites_3[] = 
{
    { 12}, { 42}, { 71}, { 88}, { 89}, {111}, {157}, {235}, {270}, {273}, {324}, {325}, {405}, {417}, {434}, {448}, {482}, {501}
};

static t_probak * szint_esely = NULL;
static int esely_calculate_ksz = 0;
static int esely_calculate_fsz = 0;

static t_torony_kiir_store * kiir_store_head = NULL;
static t_torony_kiir_store * kiir_store_tail = NULL;

extern char * torony_get_szakertelem_nev(int i)
{
    if ((i >= 0) && (i < sizeof(szakertelem_nevek) / sizeof(char *)) && szakertelem_nevek[i])
    {
	return szakertelem_nevek[i];
    }
    
    return "";
}
extern int torony_get_szakertelem_ertek(t_fordulo * fordulo, int i)
{
    if (!fordulo || !fordulo->karakter || i < 0 || i > 15)
    {
	return -1;
    }
    switch (i)
    {
	case 0:
	    return fordulo->karakter->kepessegek.szerencsejatek;
	case 1:
	    return fordulo->karakter->kepessegek.titkosiras;
	case 2:
	    return fordulo->karakter->kepessegek.zarnyitas;
	case 3:
	    return fordulo->karakter->kepessegek.banyaszat;
	case 4:
	    return fordulo->karakter->kepessegek.csapdaeszleles;
	case 5:
	    return fordulo->karakter->kepessegek.maszas;
	case 6:
	    return fordulo->karakter->kepessegek.szornyidomitas;
	case 7:
	    return fordulo->karakter->kepessegek.szornyismeret;
	case 8:
	    return fordulo->karakter->kepessegek.zene;
	case 9:
	    return fordulo->karakter->kepessegek.felderites;
	case 10:
	    return fordulo->karakter->kepessegek.harcmuveszet;
	case 11:
	    return fordulo->karakter->kepessegek.pszi;
	case 12:
	    return fordulo->karakter->kepessegek.vadaszat;
	case 13:
	    return fordulo->karakter->kepessegek.gyogyitas;
	case 14:
	    return fordulo->karakter->kepessegek.lopas;
	case 15:
	    return fordulo->karakter->kepessegek.rejtozkodes;
	default:
	    return -1;
    }
}

extern int torony_get_szakertelem_kellene(int szint, int i)
{
    if ((szint < 1) || (szint > PROBA_MAX_SZINT) || i < 0 || i > 15)
    {
	return -1;
    }
    switch (i)
    {
	case 0:
	case 1:
	case 2:
	    switch (szint)
	    {
		case 1:
		    return 4;
		case 2:
		    return 8;
		case 3:
		    return 12;
		default:
		    break;
	    }
	    break;
	case 3:
	case 4:
	case 5:
	case 6:
	case 7:
	case 8:
	    switch (szint)
	    {
		case 1:
		    return 5;
		case 2:
		    return 10;
		case 3:
		    return 15;
		default:
		    break;
	    }
	    break;
	case 9:
	case 10:
	case 11:
	case 12:
	    switch (szint)
	    {
		case 1:
		    return 10;
		case 2:
		    return 15;
		case 3:
		    return 25;
		default:
		    break;
	    }
	    break;
	case 13:
	case 14:
	case 15:
	    switch (szint)
	    {
		case 1:
		    return 10;
		case 2:
		    return 20;
		case 3:
		    return 30;
		default:
		    break;
	    }
	    break;
	default:
	    break;
    }
    return -1;
}

extern float torony_get_proba_szint_esely(int szint, t_proba_tipus tipus)
{
    float esely = 0;
    int i;
    
    if ((szint > 0) && (szint < PROBA_MAX_SZINT + 1))
    {
	for(i = 0; i < sizeof(t_probak)/sizeof(t_proba); i++)
	{
	    if (szint_esely[szint].elem[i].tipus == tipus)
	    {
		esely = szint_esely[szint].elem[i].esely;
	    }
	}
    }
    
    return esely;
}

int szint_esely_calculate(t_fordulo * fordulo)
{
    int i, j;
    
    if (!fordulo || !fordulo->karakter || !fordulo->karakter->ksz)
    {
	destroy_szint_esely();
	esely_calculate_ksz = 0;
	esely_calculate_fsz = 0;
	return -1;
    }
    
    if ((fordulo->fsz != esely_calculate_fsz) || (fordulo->karakter->ksz != esely_calculate_ksz))
    {
	destroy_szint_esely();
	if (!(szint_esely = malloc(sizeof(t_probak) * (PROBA_MAX_SZINT + 1))))
	{
	    esely_calculate_ksz = 0;
	    esely_calculate_fsz = 0;
	    return -1;
	}
	memset(szint_esely, 0, sizeof(t_probak) * (PROBA_MAX_SZINT + 1));
	esely_calculate_ksz = fordulo->karakter->ksz;
	esely_calculate_fsz = fordulo->fsz;
	
	for(i = 0; i < sizeof(t_probak)/sizeof(t_proba); i++)
	{
	    for (j = 0; j < PROBA_MAX_SZINT + 1; j++)
	    {
		szint_esely[j].elem[i].tipus = proba_conf[i].tipus;
		szint_esely[j].elem[i].esely_calculate = proba_conf[i].esely_calculate;
	    }
	}

	for(i = 0; i < sizeof(t_probak)/sizeof(t_proba); i++)
	{
	    for (j = 0; j < PROBA_MAX_SZINT + 1; j++)
	    {
		(* szint_esely[j].elem[i].esely_calculate)(fordulo, &szint_esely[j].elem[i], j);
	    }
	}
    }
    return 0;
}

extern int destroy_szint_esely(void)
{
    if (szint_esely)
    {
	free(szint_esely);
	szint_esely = NULL;
    }
}

int torony_kiir_store_add(t_proba_tipus tipus, int szint, int ssz, int ssz2, int alkoto_darab)
{
    t_torony_kiir_store * store;
    
    if (store = malloc(sizeof(t_torony_kiir_store)))
    {
	store->tipus = tipus;
	store->szint = szint;
	store->ssz = ssz;
	store->ssz2 = ssz2;
	store->alkoto_darab = alkoto_darab;
	store->next = NULL;
	
	if (kiir_store_tail)
	{
	    kiir_store_tail->next = store;
	}
	kiir_store_tail = store;
	if (!kiir_store_head)
	{
	    kiir_store_head = store;
	}
	
	return 0;
    }
    
    return -1;
}

extern int torony_kiir_store_destroy(void)
{
    t_torony_kiir_store * store;
    t_torony_kiir_store * next;
    
    for(store = kiir_store_head; store; store = next)
    {
	next = store->next;
	free(store);
    }
    
    kiir_store_head = NULL;
    kiir_store_tail = NULL;
    
    return 0;
}

extern t_torony_kiir_store * torony_kiir_store_get_head(void)
{
    return kiir_store_head;
}

t_proba * get_proba_from_probak_by_tipus(t_probak * probak, t_proba_tipus tipus)
{
    int i;
    t_proba * P = NULL;
    
    for(i = 0; i < sizeof(t_probak)/sizeof(t_proba); i++)
    {
	if (probak->elem[i].tipus == tipus)
	{
	    P = &probak->elem[i];
	    break;
	}
    }
    
    return P;
}

int torony_szamol(t_fordulo * fordulo, int szint, int * nn, float * ossz, float * esely_ossz)
{
    int i, j, n;
    float r_ossz;
    float r_esely_ossz;
    t_proba * P;
    t_proba * E;
    
    r_ossz = *ossz;
    r_esely_ossz = *esely_ossz;
    
		    for(i = 0; i < lefutas_sorok[szint]; i++)
		    {
			char output_lines_elem[PROBA_SZINT_HOSSZ * 6 + 1];
			float r_line = 1;
			float r_esely = 1;
			float n_kivetel;
			float n_esely[PROBA_SZINT_HOSSZ];
			int n_i;
			
			for (n_i = 0; n_i < PROBA_SZINT_HOSSZ; n_esely[n_i++] = 0);
			sprintf(output_lines_elem, "");
			for (j = 0; j < PROBA_SZINT_HOSSZ; j++)
			{
			    if ((proba_szintek[szint].proba[j] < 1) || (proba_szintek[szint].proba[j] > PROBA_MAX_SZINT)) continue;
			    
			    n_kivetel = 0;
			    
			    E = *lefutas[i].line[j];
			    P = get_proba_from_probak_by_tipus(&szint_esely[proba_szintek[szint].proba[j]], E->tipus);
			    
			    n_esely[j] = E->esely;
			    r_line = r_line * P->esely / 100;
			    
			    if ((szint >= 5) && (szint <=6))
			    {
				n_kivetel = 0;
			    }
			    else
			    {
				if (j >= 1) n_kivetel += n_esely[j-1];
				if (j >= 2) n_kivetel += n_esely[j-2];
			    }
			    r_esely = r_esely * E->esely / (100 - n_kivetel);
			    
			    sprintf(output_lines_elem, "%s%s%d ", output_lines_elem, E->nev, proba_szintek[szint].proba[j]);
			}
			
			r_ossz += r_line * r_esely;
			r_esely_ossz += r_esely;
#ifdef DEBUG
			debug(fordulo, "torony: %4d " TORONY_SZAM_FORMAT ": %s => " TORONY_SZAM_FORMAT " (" TORONY_SZAM_FORMAT ", " TORONY_SZAM_FORMAT ")\n", 
				(*nn)+1, r_esely*100, output_lines_elem, r_line*100, r_ossz * 100, r_esely_ossz * 100);
#endif
			(*nn)++;
		    }
    *ossz = r_ossz;
    *esely_ossz = r_esely_ossz;
    return 0;
}

extern float torony(t_fordulo * fordulo, int szint)
{
    int i, j, n;
    int a, b, c, d;
    t_proba * P;
    t_proba * E;
    float r_ossz;
    float r_esely_ossz;
    float tmp_esely;
    
    n = 0;
    r_ossz = 0;
    r_esely_ossz = 0;
    
    szint--;
    
    if ((szint < 0) || (szint > 7))
    {
	return -1;
    }

    szint_esely_calculate(fordulo);
    
#ifdef DEBUG
    debug(fordulo, "torony: feldolgozas kezdete: %d. szint\n", szint+1);
#endif

    if (szint == 5)
    {
	A = &proba_conf[2];
	B = &proba_conf[2];
	C = &proba_conf[2];
	D = &proba_conf[2];
	tmp_esely = proba_conf[2].esely;
	proba_conf[2].esely = 100;
	torony_szamol(fordulo, szint, &n, &r_ossz, &r_esely_ossz);
	proba_conf[2].esely = tmp_esely;
    }
    else if (szint == 6)
    {
	A = &proba_conf[0];
	B = &proba_conf[0];
	C = &proba_conf[0];
	D = &proba_conf[0];
	tmp_esely = proba_conf[0].esely;
	proba_conf[0].esely = 100;
	torony_szamol(fordulo, szint, &n, &r_ossz, &r_esely_ossz);
	proba_conf[0].esely = tmp_esely;
    }
    else
    {
	for(a = 0; a < sizeof(t_probak)/sizeof(t_proba); a++)
	{
	    A = &proba_conf[a];
	    for(b = 0; b < sizeof(t_probak)/sizeof(t_proba); b++)
	    {
		if (a == b) continue;
		B = &proba_conf[b];
		for(c = 0; c < sizeof(t_probak)/sizeof(t_proba); c++)
		{
		    if ((c == a) || (c == b)) continue;
		    C = &proba_conf[c];
		    for(d = 0; d < sizeof(t_probak)/sizeof(t_proba); d++)
		    {
			if ((d == a) || (d == b) || (d == c)) continue;
			D = &proba_conf[d];
			torony_szamol(fordulo, szint, &n, &r_ossz, &r_esely_ossz);
		    }
		}
	    }
	}
    }
    
    r_ossz = r_ossz / r_esely_ossz * 100;
#ifdef DEBUG
    debug(fordulo, "torony: %d. szint megcsinalasanak eselye: " TORONY_SZAM_FORMAT "\n", szint+1, r_ossz);
#endif
    return r_ossz;
}

extern int esely_calculate_szakertelem(t_fordulo * fordulo, t_proba * proba, int szint)
{
    float esely;
    int n, x;
    int i;
    int hiba;
    int hiba1;
    int hiba2;
	
    esely = 100;
    n = 16;
    x = 0;
    
    if (proba->tipus != proba_szakertelem)
    {
	return -1;
    }
    
    if (!fordulo)
    {
	return -1;
    }

    for (i = 0; i < 15; i++)
    {
	if ((i == 14) && (torony_get_szakertelem_ertek(fordulo, i) == 0))
	{
	    n--;
	    continue;
	}
	
	if ((torony_get_szakertelem_ertek(fordulo, i) < 0) || (torony_get_szakertelem_kellene(szint, i) < 0))
	{
	    n--;
	    continue;
	}
	
	hiba = 0;
	hiba1 = 0;
	hiba2 = 0;
	
	if (torony_get_szakertelem_ertek(fordulo, i) < torony_get_szakertelem_kellene(szint, i))
	{
	    hiba = 1;
	    torony_kiir_store_add(proba_szakertelem, szint, i, 0, 0);
	}
	
	switch (szint)
	{
	    case 1:
		if ((i == 11) && !karakter_spelllist_check_spell(fordulo->karakter, 74)) hiba1 = 74;
		break;
	    case 2:
		if ((i ==  6) && !karakter_targylist_check_targy_nalad(fordulo->karakter, 165)) hiba1 = 165;
		if ((i == 11) && !karakter_spelllist_check_spell(fordulo->karakter, 104)) hiba1 = 104;
		break;
	    case 3:
		if ((i ==  4) && !karakter_spelllist_check_spell(fordulo->karakter, 94)) hiba1 = 94;
		if ((i ==  5) && !karakter_targylist_check_targy_nalad(fordulo->karakter, 392)) hiba1 = 392;
		if ((i ==  6) && !karakter_targylist_check_targy_nalad(fordulo->karakter, 273)) hiba1 = 273;
		if ((i ==  6) && !karakter_targylist_check_targy_nalad(fordulo->karakter, 92)) hiba2 = 92;
		if ((i ==  9) && !karakter_spelllist_check_spell(fordulo->karakter, 78)) hiba1 = 78;
		if ((i == 11) && !karakter_spelllist_check_spell(fordulo->karakter, 117)) hiba1 = 117;
		if ((i == 14) && !karakter_spelllist_check_spell(fordulo->karakter, 76)) hiba1 = 76;
		if ((i == 15) && !karakter_targylist_check_targy_nalad(fordulo->karakter, 211)) hiba1 = 211;
		break;
	    default:
		break;
	}
	if (hiba1)
	{
	    torony_kiir_store_add(proba_szakertelem, szint, i, hiba1, 0);
	}
	if (hiba2)
	{
	    torony_kiir_store_add(proba_szakertelem, szint, i, hiba2, 0);
	}
	if (hiba || hiba1 || hiba2)
	{
	    x++;
	}
    }
    
    if (n != 0)
    {
	esely = (float)100 * ((float)n - (float)x) / (float)n;
    }
    else
    {
	esely = 0;
    }

#ifdef DEBUG
    debug(fordulo, "esely_calculate_szakertelem: szint=%d, esely=" TORONY_SZAM_FORMAT "\n", szint, esely);
#endif
    proba->esely = esely;
    return 0;
}

extern int esely_calculate_info(t_fordulo * fordulo, t_proba * proba, int szint)
{
    float esely;
    int x_szorny, x_targy, n_szorny, n_targy;
    int i;
    int * ii_szorny;
    int * ii_targy;
    int percent;
    t_cache_monster_flag flag_szorny;
    t_cache_item_flag flag_targy;
    
    esely = 100;
    percent = 0;
    n_szorny = 0;
    x_szorny = 0;
    n_targy = 0;
    x_targy = 0;
    
    if (proba->tipus != proba_info)
    {
	return -1;
    }
    
    if (!fordulo)
    {
	return -1;
    }
    
    ii_szorny = NULL;
    ii_targy = NULL;
    
    switch (szint)
    {
	case 1:
	    n_szorny = sizeof(infolista_szorny1)/sizeof(int);
	    ii_szorny = infolista_szorny1;
	    n_targy = sizeof(infolista_targy1)/sizeof(int);
	    ii_targy = infolista_targy1;
	    break;
	
	case 2:
	    n_szorny = sizeof(infolista_szorny2)/sizeof(int);
	    ii_szorny = infolista_szorny2;
	    n_targy = sizeof(infolista_targy2)/sizeof(int);
	    ii_targy = infolista_targy2;
	    break;
	
	case 3:
	    n_szorny = sizeof(infolista_szorny3)/sizeof(int);
	    ii_szorny = infolista_szorny3;
	    n_targy = sizeof(infolista_targy3)/sizeof(int);
	    ii_targy = infolista_targy3;
	    break;
	
	default:
	    n_szorny = 0;
	    ii_szorny = NULL;
	    n_targy = 0;
	    ii_targy = NULL;
	    break;
    }
    
    for (i = 0; ii_szorny && (i < n_szorny); i++, percent = 0)
    {
	flag_szorny = (t_cache_monster_flag)cache_check_monster(fordulo, fordulo->cache, ii_szorny[i], &percent, 0, NULL);
#ifdef DEBUG
	debug(fordulo, "esely_calculate_info_szorny: szint=%d, ssz=%d, flag=%s\n", szint, ii_szorny[i], ((flag_szorny == cache_monster_flag_ismert)?"ismert":"nem ismert"));
#endif
	if (flag_szorny == cache_monster_flag_ismert)
	{
	    x_szorny++;
	}
	else
	{
	    torony_kiir_store_add(proba_info, szint, ii_szorny[i], (int)proba_info_szorny, 0);
	}
    }
    
    for (i = 0; ii_targy && (i < n_targy); i++)
    {
	flag_targy = (t_cache_item_flag)cache_check_item(fordulo, fordulo->cache, ii_targy[i]);
#ifdef DEBUG
	debug(fordulo, "esely_calculate_info_targy: szint=%d, ssz=%d, flag=%s\n", szint, ii_targy[i], (((flag_targy == cache_item_flag_ismert) || (flag_targy == cache_item_flag_hu))?"ismert":"nem ismert"));
#endif
	if ((flag_targy == cache_item_flag_ismert) || (flag_targy == cache_item_flag_hu))
	{
	    x_targy++;
	}
	else
	{
	    torony_kiir_store_add(proba_info, szint, ii_targy[i], proba_info_targy, 0);
	}
    }
    
    if (n_szorny + n_targy !=0)
    {
	esely = (float)100 * ((float)x_szorny + (float)x_targy) / ((float)n_szorny + (float)n_targy);
    }
    else
    {
	esely = 0;
    }
    
#ifdef DEBUG
    debug(fordulo, "esely_calculate_info: szint=%d, esely=" TORONY_SZAM_FORMAT "\n", szint, esely);
#endif
    proba->esely = (esely + esely*esely/100) / 2;
    return 0;
}

extern int esely_calculate_oles(t_fordulo * fordulo, t_proba * proba, int szint)
{
    float esely;
    int x, n;
    int i;
    int * ii;
    int percent, ossz_percent, fix_percent;
    t_cache_monster_flag flag;
    int oles_array[CACHE_MONSTER_MEGOLES_LEN];
    
    esely = 100;
    ossz_percent = 0;
    percent = 0;
    n = 0;
    x = 0;
    
    if (proba->tipus != proba_oles)
    {
	return -1;
    }
    
    if (!fordulo)
    {
	return -1;
    }
    
    ii = NULL;
    
    switch (szint)
    {
	case 1:
	    n = sizeof(szornylista_1)/sizeof(int);
	    ii = szornylista_1;
	    break;
	
	case 2:
	    n = sizeof(szornylista_2)/sizeof(int);
	    ii = szornylista_2;
	    break;
	
	case 3:
	    n = sizeof(szornylista_3)/sizeof(int);
	    ii = szornylista_3;
	    break;
	
	default:
	    n = 0;
	    ii = NULL;
	    break;
    }
    
    for (i = 0; ii && (i < n); i++, percent = 0)
    {
	flag = (t_cache_monster_flag)cache_check_monster(fordulo, fordulo->cache, ii[i], &percent, 0, NULL);
#ifdef DEBUG
	debug(fordulo, "esely_calculate_oles: szint=%d, ssz=%d, percent=%d, n=%d\n", szint, ii[i], percent, n);
#endif
	fix_percent = torony_szorny_oles_get_percent(ii[i]);
	
	if ((fix_percent >= 0) && (fix_percent <= 100))
	{
	    percent = fix_percent;
#ifdef DEBUG
	    debug(fordulo, "esely_calculate_oles: szint=%d, ssz=%d, fix_percent=%d\n", szint, ii[i], percent);
#endif
	}
	else if (flag == cache_monster_flag_ismert)
	{
	    // nem csinalunk semmit, csak kikeruljuk az else agat
	}
	else
	{
	    torony_kiir_store_add(proba_oles, szint, ii[i], proba_oles_noinfo, 0);
	    continue;
	}
	
	if (percent < 100)
	{
	    torony_kiir_store_add(proba_oles, szint, ii[i], proba_oles_nemoli, percent);
	}
	ossz_percent += percent;
#ifdef DEBUG
	debug(fordulo, "esely_calculate_oles: szint=%d, ssz=%d, ossz_percent=%d\n", szint, ii[i], ossz_percent);
#endif
    }
    
    if (n != 0)
    {
	esely = (float)ossz_percent / (float)n;
    }
    else
    {
	esely = 0;
    }
        
#ifdef DEBUG
    debug(fordulo, "esely_calculate_oles: szint=%d, esely=" TORONY_SZAM_FORMAT "\n", szint, esely);
#endif
    proba->esely = esely;
    return 0;
}

extern int esely_calculate_keszites(t_fordulo * fordulo, t_proba * proba, int szint)
{
    float esely;
    int x, n;
    int i;
    int nalad;
    int hiba;
    t_cache_item_flag flag;
    t_targy_alkoto * targy_alkoto;
    t_targy_keszites * targy_keszites;
    t_targy * targy;
    
    esely = 100;
    n = 0;
    x = 0;
    
    if (proba->tipus != proba_keszites)
    {
	return -1;
    }
    
    if (!fordulo)
    {
	return -1;
    }
    
    targy_keszites = NULL;
    targy_alkoto = NULL;
    
    switch (szint)
    {
	case 1:
	    n = sizeof(targykeszites_1)/sizeof(t_targy_keszites);
	    targy_keszites = targykeszites_1;
	    break;
	
	case 2:
	    n = sizeof(targykeszites_2)/sizeof(t_targy_keszites);
	    targy_keszites = targykeszites_2;
	    break;
	
	case 3:
	    n = sizeof(targykeszites_3)/sizeof(t_targy_keszites);
	    targy_keszites = targykeszites_3;
	    break;
	
	default:
	    n = 0;
	    targy_keszites = NULL;
	    targy_alkoto = NULL;
	    break;
    }
    
    for (i = 0; targy_keszites && (i < n); i++)
    {
	flag = (t_cache_item_flag)cache_check_item(fordulo, fordulo->cache, targy_keszites[i].ssz);
#ifdef DEBUG
	debug(fordulo, "esely_calculate_keszites: szint=%d, ssz=%d, flag=%s\n", szint, targy_keszites[i].ssz, (((flag == cache_item_flag_ismert) || (flag == cache_item_flag_hu))?"ismert":"nem ismert"));
#endif
	if ((flag != cache_item_flag_ismert) && (flag != cache_item_flag_hu))
	{
	    torony_kiir_store_add(proba_keszites, szint, targy_keszites[i].ssz, 0, 0);
	}
	
	if (targy = get_targy_from_ssz(targy_keszites[i].ssz))
	{
	    if ((targy_keszites[i].ssz == 448) && !karakter_spelllist_check_spell(fordulo->karakter, 100))
	    {
		hiba++;
		torony_kiir_store_add(proba_keszites, szint, targy_keszites[i].ssz, -2, 0);
#ifdef DEBUG
		debug(fordulo, "esely_calculate_keszites: szint=%d, ssz=%d, nincs varazsital fozes a lotuszfozethez\n", szint, targy_keszites[i].ssz);
#endif
	    }
	    for (targy_alkoto = targy->alkoto, hiba = 0; targy_alkoto; targy_alkoto = targy_alkoto->next)
	    {
		if (targy_alkoto->ssz && targy_alkoto->darab)
		{
		    nalad = karakter_targylist_check_targy_nalad(fordulo->karakter, targy_alkoto->ssz);
#ifdef DEBUG
		    debug(fordulo, "esely_calculate_keszites: szint=%d, ssz=%d, alkoto=%d, kellene=%d, nalad=%d\n", szint, targy_keszites[i].ssz, targy_alkoto->ssz, targy_alkoto->darab, nalad);
#endif
		    if (nalad < targy_alkoto->darab)
		    {
			hiba++;
			torony_kiir_store_add(proba_keszites, szint, targy_keszites[i].ssz, targy_alkoto->ssz, targy_alkoto->darab - nalad);
		    }
		    if ((targy_alkoto->ssz == 152) && (fordulo->karakter->kepessegek.banyaszat < 4))
		    {
			hiba++;
			torony_kiir_store_add(proba_keszites, szint, targy_keszites[i].ssz, -1, 0);
#ifdef DEBUG
			debug(fordulo, "esely_calculate_keszites: szint=%d, ssz=%d, alkoto=%d, nincs 4es banyaszat a vastargyakhoz\n", szint, targy_keszites[i].ssz, targy_alkoto->ssz);
#endif
		    }
		}
	    }
	    if (hiba == 0)
	    {
		x++;
	    }
	    else
	    {
#ifdef DEBUG
		debug(fordulo, "esely_calculate_keszites: szint=%d, ssz=%d, hiba=%d\n", szint, targy_keszites[i].ssz, hiba);
#endif
	    }
	}
    }
    
    if (n != 0)
    {
	esely = (float)100 * (float)x / (float)n;
    }
    else
    {
	esely = 0;
    }
    
#ifdef DEBUG
    debug(fordulo, "esely_calculate_keszites: szint=%d, esely=" TORONY_SZAM_FORMAT "\n", szint, esely);
#endif
    proba->esely = esely;
    return 0;
}

extern int torony_szorny_oles_set_percent(int ssz, int percent, t_confset confset)
{
    t_szorny_oles * szorny_oles;
    int ret = 0;
    
    for (szorny_oles = szorny_oles_lista; ssz && szorny_oles; szorny_oles = szorny_oles->next)
    {
	if (szorny_oles->ssz == ssz)
	{
	    break;
	}
    }
    
    if (ssz && (percent >= 0) && (percent <= 100))
    {
	if (szorny_oles && szorny_oles->ssz == ssz)
	{
	    if (szorny_oles->confset == confset_commandline)
	    {
		return 0;
	    }
	}
	else if (szorny_oles = malloc(sizeof(t_szorny_oles)))
	{
	    szorny_oles->ssz = ssz;
	    szorny_oles->next = szorny_oles_lista;
	    szorny_oles_lista = szorny_oles;
	}
	else
	{
	    return -1;
	}
	szorny_oles->percent = percent;
	szorny_oles->confset = confset;
#ifdef DEBUG
	debug(NULL, "torony_szorny_oles_set_percent: ssz=%d, percent=%d, confset=%d\n", ssz, percent, confset);
#endif
    }
    
    return ret;
}

extern int torony_szorny_oles_get_percent(int ssz)
{
    t_szorny_oles * szorny_oles;
    int ret = -1;
    
    for (szorny_oles = szorny_oles_lista; szorny_oles; szorny_oles = szorny_oles->next)
    {
	if (szorny_oles->ssz == ssz)
	{
	    ret = szorny_oles->percent;
	    break;
	}
    }
    
    return ret;
}

extern int torony_szorny_oles_lista_destroy(int flag)
{
    t_szorny_oles * szorny_oles;
    t_szorny_oles * next;
    t_szorny_oles * marad;
    t_szorny_oles * marad_lista;
    
    marad_lista = NULL;
    for (szorny_oles = szorny_oles_lista; szorny_oles; szorny_oles = next)
    {
	next = szorny_oles->next;
	if (flag || (szorny_oles->confset != confset_commandline))
	{
	    free(szorny_oles);
	}
	else
	{
	    if (!marad_lista)
	    {
		marad_lista = szorny_oles;
	    }
	    else
	    {
		marad->next = szorny_oles;
	    }
	    marad = szorny_oles;
	}
    }
    szorny_oles_lista = marad_lista;
    
    return 0;
}

extern int torony_unload(void)
{
    destroy_szint_esely();
    torony_kiir_store_destroy();
    torony_szorny_oles_lista_destroy(1);
}
